/**
 * Title:        JavaCPC by http://cpc-live.com
 * Description:  JAVA emulator for Amstrad Homecomputers
 * Copyright:    Copyright (c) 2002-2008
 * Company:
 * @author Devilmarkus
 * based on JEMU
 * author Richard
 * @version 6.1 - X-mas edition 2008
 * 
 */

package jemu.ui;
import java.net.*;
import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;

import java.io.*;  
import javax.imageio.*;  
import javax.swing.*;
import javax.swing.border.*;

import jemu.core.Util;
import jemu.core.device.*;
import jemu.core.device.FileDescriptor;
import jemu.core.device.floppy.*;
import jemu.settings.Settings;
import javax.swing.JSlider;
import javax.swing.event.*;
import jemu.util.hexeditor.*;

public class JEMU extends Applet implements KeyListener, MouseListener, ItemListener,
  ActionListener, FocusListener, Runnable, DriveListener, MouseMotionListener
{
    //
    // Informations for updatecheck
    //
        String version = "6.1";
        boolean checkVer = true;
    //
        Locale loc;
        String localkeys="";
        
     String keys ="";
      class ColoredComponent extends JLabel {

     ColoredComponent (Color color) {
        setOpaque (false);
        setBackground (color);
        Dimension d = new Dimension (10, 8);
        setPreferredSize (d);
        setMaximumSize (d);
        setMinimumSize (d);
        setBorder (new LineBorder (Color.DARK_GRAY));
        //setBorder (new BevelBorder(BevelBorder.RAISED));
        setDoubleBuffered (false);
        }
     }
        String update ="";
        HexEditor hexi;
 public boolean runner = false;
      JFrame snaChooser = new JFrame("Save Snapshot");
      JButton s64 = new JButton("64k");
      JButton s128 = new JButton("128k");
      JButton s256 = new JButton("256k");
      JButton s512 = new JButton("512k");
      JButton cancel = new JButton("Cancel");
      JLabel Sn = new JLabel("Choose Snapshot-format:");
  
  JLabel Moniup     =   new JLabel(new ImageIcon(getClass().getResource("image/moniup.jpg")));
  JLabel Monidown   =   new JLabel(new ImageIcon(getClass().getResource("image/monidown.jpg")));
  JLabel Monileft   =   new JLabel(new ImageIcon(getClass().getResource("image/monileft.jpg")));
  JLabel Moniright  =   new JLabel(new ImageIcon(getClass().getResource("image/moniright.jpg")));
    public static JTextArea Status1 = new JTextArea("");
  public static JTextArea Status2 = new JTextArea("");
     JPanel StatusPanel = new JPanel();
  
      JPanel Monitoruppanel = null;
      JPanel Monitordownpanel = null;
      JPanel Monitorleftpanel = null;
      JPanel Monitorrightpanel = null;
      
    JFrame screenpreview;
    Frame options;    
    public static boolean Options = false;
    JButton ok = new JButton("OK");
    JLabel sprev = new JLabel(); 
    BufferedImage images;
     int xpos; 
     int ypos;
     int xoldpos; 
     int yoldpos; 
     protected boolean ctrl = false;
        
   public static int screenshottimer = 0;
   public static int screentimer = 0;
   public static int dsksavetimer = 0;
   public static int dskmaketimer = 0;
  protected boolean Vhold = false;
  protected String server;
  public String MachineMemory = "512";
  public static AudioClip turnOn = null;
  
  public boolean audiooutput = true;
  public boolean floppyoutput = true;
  public boolean altjoystick = false;
  private int loadtimer = 0;
  public boolean mousejoy = false;
  
  protected int sizecounter = 0;
  
  private boolean stretcher = true;
  public int flopsound;
  private String autoloadprog;
  private String autoloadprogram = "~none~";
  private String autotypetext = "~none~";
  private int loadprogtimer = 0;
  private int simpletimer   = 0;
  private int stopsimple    = 0;
  private String DSKfile;
  private String                autostartProg   = null;
  private String                autostartDisk   = null;
  private String                setComputers    = null;
  private String                discb           = null;
  private String                discc           = null;
  private String                discd           = null;
  private String                Monitor         = null;
  private String                compsys         = null;
  private int                   pausetimer      = 0;
  private int                   paused          = 0;
  private int                   autoload        = 0;
  public static int             autoloader      = 0;
  protected Computer            computer        = null;
  public static String          compvolume;
  public static String          mon;
  public static int             outvolume       = 4;
  public static int             checkvolume     = 4;
  public static int             winx1 = 532; // 916
  public static int             winy1 = 402; // 672
  
  protected Color activ         = new Color(0,150, 0);
  protected Color inactiv       = new Color(150, 0, 0);
  protected Color textactiv     = new Color(0, 255, 0);
  protected Color textinactiv   = new Color(255, 0, 0);
  
  protected Display            display          = new Display();
  protected int                dtimer           = 1;
  protected JLabel             jlComputer       = new JLabel("System  ");
  protected JLabel             jlDrive          = new JLabel("Disc drive ");
  protected JLabel             jlImage          = new JLabel("Media");
  protected JLabel             jmMerge          = new JLabel("Merges 2 single-sided DSK to 1 double sided");
  protected JLabel             jmSavec          = new JLabel("Save canceled");
  public static String         jmSavefile       = "Select name for your dsk file (Ends with '.dsk')";
 
  //protected JComboBox          jcbComputer      = new JComboBox();
  protected JComboBox          jcbDrive         = new JComboBox();
  protected JComboBox          jcbImage         = new JComboBox();
  protected JComboBox          driveHead        = new JComboBox(new String[] { "Head 0", "Head 1" });
  protected GridBagConstraints gbcConstraints   = null;
  protected boolean            isStandalone     = false;
  protected Debugger           debugger            = null;
  protected boolean            started          = false;
  public    boolean            large;   
  protected boolean            joystick;
  protected boolean             executable      = false;
  public  boolean               autosave; 
  public boolean                autoboot;  
  public  int                   autobooter; 
  public  boolean               showmessage ;
  protected Thread             focusThread      = null;
  protected boolean            gotGames         = false;
  private ResourceBundle       msg_ui;
  protected String             Language         = null;
  protected String             cname            = null;
  protected String             loadName         = null;
  protected Color              background;
  
  protected JSlider volumeslider    = new JSlider();
  protected JSlider bvolumeslider    = new JSlider();
          JCheckBox effect = new JCheckBox("Stereo Effect");
  public static JSlider lslider         = new JSlider();
  public static JSlider rslider         = new JSlider();
  protected JSlider vslider         = new JSlider();
  final Hashtable labels = new Hashtable ();
  final Hashtable blabels = new Hashtable ();
  final Hashtable leftlabels = new Hashtable ();
  final Hashtable rightlabels = new Hashtable ();

  
  public static boolean onTop;
  protected boolean fsound;
  protected boolean notebook;
  protected boolean hideframe;
  protected boolean skinned;
  public String optionp;
  public static boolean togglesize = true;
  public static boolean fullscreen;
  
  
  boolean osd;


  
  JLabel JJemu = new JLabel(new ImageIcon(getClass().getResource("image/jabout.gif")));
  JLabel JLogo = new JLabel(new ImageIcon(getClass().getResource("image/javacpc.gif")));
  

  
 public static JFrame frame = new JFrame();
    
  // private ResourceBundle msg_dbg; // Not used yet
  public String getParameter(String key, String def) {
    return this.isStandalone ? System.getProperty(key, def) : (getParameter(key) != null ? getParameter(key) : def);
  }

  // The graphical part of JEMU

  private GridBagConstraints getGridBagConstraints(int x, int y, double weightx,double weighty,
    int width, int fill)
  {
    if (this.gbcConstraints == null) {
      this.gbcConstraints = new GridBagConstraints();
    }
    this.gbcConstraints.gridx = x;
    this.gbcConstraints.gridy = y;
    this.gbcConstraints.weightx = weightx;
    this.gbcConstraints.weighty = weighty;
    this.gbcConstraints.gridwidth = width;
    this.gbcConstraints.fill = fill;
    return this.gbcConstraints;
  }

  private JPanel getControlPanel() {
     final JPanel panel = new JPanel();
    panel.setLayout(new GridBagLayout());
    return panel;
  }


  public JEMU() {
    enableEvents(AWTEvent.KEY_EVENT_MASK);
  }

public void init() {
    
        loc = getLocale();
        localkeys = loc.toString().toUpperCase();
        if (localkeys.equals("DE_DE"))
            keys ="German keyboard  ";
        else
        if (localkeys.equals("ES_ES"))
            keys ="Spanish keyboard  ";
        else
            keys ="English keyboard  ";
        Keys.setLabel(keys);
        
      Switches.executable = false;
      
      try {
                server = getCodeBase().toString();
            } catch (final Exception e) {
                Switches.executable = true;
                executable = true;
            } 
      System.out.println("executable is " + executable);
      Switches.doublesize = Settings.getBoolean(Settings.DOUBLE, false);
      Switches.triplesize = Settings.getBoolean(Settings.TRIPLE, false);
      if (!executable){
      Switches.doublesize = Util.getBoolean(getParameter("DOUBLE", "false"));
      Switches.triplesize = Util.getBoolean(getParameter("TRIPLE", "false"));
      }
          checkDouble.setState(Switches.doublesize);
          checkTriple.setState(Switches.triplesize);
          checkFull.setState(fullscreen);
          
      showmenu = Settings.getBoolean(Settings.showmenu, showmenu);
      if (showmenu)
            frame.setMenuBar(JavaCPCMenu);

    showmessage = Settings.getBoolean(Settings.MESSAGE, true);
      if (showmessage){
         message();
      }    
      autorun();
      simpleBoot();

    requestFocus();
  }
  
  public void autorun(){
    autoloadprog = Settings.get(Settings.AUTOLOAD, null);
    autoloadprog = getParameter("AUTOLOAD", autoloadprog);
    autoloadprogram = autoloadprog;
    stopsimple = 0;
    if (autoloadprog != null){
        if (autoloadprog.equals("~none~")){}
        else {
    runner = true;
            stopsimple = 1;
            if (autoloadprog.startsWith("|")){
               loadprogtimer = 1;
               Switches.loadauto = autoloadprog + "\n";
               Settings.set(Settings.AUTOLOAD, "~none~");           
            }
            else{
               loadprogtimer = 1;
               Switches.loadauto = "RUN\"" + autoloadprog + "\"\n";
               Settings.set(Settings.AUTOLOAD, "~none~");
            }
        }
    }     
    autoloadprog = Settings.get(Settings.AUTOTYPE, null);
    autoloadprog = getParameter("AUTOTYPE", autoloadprog);
    autotypetext = autoloadprog;
    stopsimple = 0;
    if (autoloadprog != null){
        if (autoloadprog.equals("~none~")){}
        else {
    runner = false;
            stopsimple = 1;
               loadprogtimer = 1;
               Switches.loadauto = autoloadprog + "\n";
               Settings.set(Settings.AUTOTYPE, "~none~");
        }
    }
  }
  
  public void reBoot(){
    computer.reset();
    Display.showpause = 0;
    computer.start();
    stopsimple = 0;
    if (runner){
    if (autoloadprogram != null){
        if (autoloadprogram.equals("~none~")){}
        else {
            stopsimple = 1;
            if (autoloadprogram.startsWith("|")){
               loadprogtimer = 1;
               Switches.loadauto = autoloadprogram + "\n";           
            }
            else{
               loadprogtimer = 1;
               Switches.loadauto = "RUN"+ '"' + autoloadprogram + '"' + "\n";
            }
        }
    }
    }
    else
        if (autotypetext != null){
        if (autotypetext.equals("~none~")){}
        else {
            stopsimple = 1;
               loadprogtimer = 1;
               Switches.loadauto = autotypetext+ "\n";  
        }
        }
  }

  
  public void simpleBoot(){
      if (stopsimple != 1){
      //String simpleboot = Settings.get(Settings.SIMPLEBOOT, null);
      DSKfile = getParameter("SIMPLEBOOT", null);
             
      if (DSKfile != null){
          Settings.set(Settings.AUTOLOAD, DSKfile);
          simpletimer = 1;
          autorun();
      }
      }
  }
  
  public void loaddata(){
      Component framer = this;
      if (executable)
        frame.setAlwaysOnTop(false);
      while (!(framer instanceof Frame)) {
        framer = framer.getParent();
      }    
      
      final FileDialog dlg = new FileDialog((Frame) framer, "Load Emulator File", FileDialog.LOAD);
      dlg.setFile("*.sna; *.dsk; *.zip; *.cdt; *.tzx; *.bin");
      dlg.setVisible(true);
      if (dlg.getFile() != null) {
        loadFile(Computer.TYPE_UNKNOWN, dlg.getDirectory() + dlg.getFile(), false);
      }
   
      if (executable)
        frame.setAlwaysOnTop(onTop);
      this.display.requestFocus();
  }  
  public void setSounds(AudioClip monion) {
    turnOn = monion;
  }
  public void SoundInit(){
      
      URL url = getClass().getResource("sound/monitoron.wav");
      if (url != null) turnOn = Applet.newAudioClip(url);
      setSounds(turnOn);
  }

   
  public void start() {
      skinned = Util.getBoolean(getParameter("SKINNED", "false"));
      if (skinned)
          addSkin();
      
        new Autotype();
        new CPCPrinter();
        new Console();
       SoundInit();


       try{
        UpdateCheck(); 
       }
       catch (Exception et)
       {  
           System.out.println(et.getMessage());
       }
       
    try {
      
      System.out.println("init()");  
      removeAll();
      this.background = getBackground();
      setBackground(Color.DARK_GRAY);
      setLayout(new BorderLayout());
      add(this.display, BorderLayout.CENTER);
      this.display.setDoubleBuffered(true);
      this.display.setBackground(Color.DARK_GRAY);
      this.display.addKeyListener(this);
      this.display.addMouseListener(this);
      this.display.addFocusListener(this);
      this.display.addMouseMotionListener(this); 
      

      // Parameters

      compvolume = Settings.get(Settings.VOLUME, "4");

      compvolume = getParameter("VOLUME", compvolume);
        
      if (compvolume.equals(null))
          compvolume = "4";
      System.out.println("Volume is set to " + compvolume);
      if (compvolume.equals("4"))
          outvolume = 4;
      if (compvolume.equals("3"))
          outvolume = 3;
      if (compvolume.equals("2"))
          outvolume = 2;
      if (compvolume.equals("1"))
          outvolume = 1;
      if (compvolume.equals("0"))
          outvolume = 0;
      
      Switches.volume = outvolume;

        volumeslider.setMinimum(0);    //stellt den Minimalwert auf 0 ein
        volumeslider.setMaximum(4);  //stellt den Maximalwert auf 4 ein
        volumeslider.setValue(outvolume);     //selektiert den Wert von outvolume
        volumeslider.setOrientation(JSlider.VERTICAL);    //stellt den Schieberegler horizontal auf
        volumeslider.setPaintTicks(false);    //Striche werden angezeigt
        volumeslider.setPaintLabels(true);  //Zahlen werden nicht angezeigt
        volumeslider.setPaintTrack(true);    //Balken wird angezeigt
        volumeslider.setMajorTickSpacing(1); //Abstände im Großraster
        volumeslider.setPreferredSize(new Dimension(16, 90));    
        volumeslider.setBackground(Color.DARK_GRAY);
        volumeslider.setForeground(new Color(255, 255, 255));
        volumeslider.setBorder(new EtchedBorder());
        volumeslider.setSnapToTicks(true);
        volumeslider.setDoubleBuffered(false);
        checkvolume = outvolume;
        
        for (int i = 0; i < volumeslider.getMaximum (); i++)
            labels.put (new Integer (i), new ColoredComponent (i < volumeslider.getMaximum () / 2 ? Color.green : i < volumeslider.getMaximum () * 3/4 ? Color.green : Color.red));
        volumeslider.setLabelTable (labels);
      
        volumeslider.addChangeListener (new ChangeListener () {
          private int lastValue = 0;
          
          public void stateChanged (ChangeEvent e) {
             if (volumeslider.getValue () < lastValue)
                for (int i = volumeslider.getValue (); i < lastValue; i++)
                    ((JComponent) labels.get (new Integer (i))).setOpaque (false);
                else for (int i = lastValue; i < volumeslider.getValue (); i++)
                         ((JComponent) labels.get (new Integer (i))).setOpaque (true);

             lastValue = volumeslider.getValue ();
             volumeslider.repaint ();
             }
          });
      if (Switches.volume == 4){
        //volumeslider.setBackground(Color.DARK_GRAY);
          compvolume = "4";}
      if (Switches.volume == 3){
        //volumeslider.setBackground(new Color(100, 70, 70));
          compvolume = "3";}
      if (Switches.volume == 2){
        //volumeslider.setBackground(new Color(120, 70, 70));
          compvolume = "2";}
      if (Switches.volume == 1){
       // volumeslider.setBackground(new Color(140, 70, 70));
          compvolume = "1";}
      if (Switches.volume == 0){
        //  volumeslider.setBackground(new Color(160, 70, 70));
          compvolume = "0";}
        
          
          effect.addItemListener (new ItemListener () {
          public void itemStateChanged (ItemEvent e){
              if (e.getSource() == effect)
                  if (e.getStateChange() == ItemEvent.DESELECTED){
                      Switches.effect = false;
                  Settings.setBoolean(Settings.EFFECT, false);}
                  else{
                      Switches.effect = true;
                  Settings.setBoolean(Settings.EFFECT, true);
                  }
          }
          });
          
        bvolumeslider.setMinimum(0);    //stellt den Minimalwert auf 0 ein
        bvolumeslider.setMaximum(100);  //stellt den Maximalwert auf 4 ein
        bvolumeslider.setValue(Util.hexValue(Settings.get(Settings.DBVOLUME, "32"))); 
        Switches.Blastervolume = bvolumeslider.getValue();
        bvolumeslider.setOrientation(JSlider.VERTICAL);    //stellt den Schieberegler horizontal auf
        bvolumeslider.setPaintTicks(false);    //Striche werden angezeigt
        bvolumeslider.setPaintLabels(true);  //Zahlen werden nicht angezeigt
        bvolumeslider.setPaintTrack(true);    //Balken wird angezeigt
        bvolumeslider.setMajorTickSpacing(5); //Abstände im Großraster
        bvolumeslider.setPreferredSize(new Dimension(16, 90));    
        bvolumeslider.setBackground(Color.DARK_GRAY);
        bvolumeslider.setForeground(new Color(255, 255, 255));
        bvolumeslider.setBorder(new EtchedBorder());
        bvolumeslider.setSnapToTicks(true);
        bvolumeslider.setDoubleBuffered(false);
        
                for (int i = 0; i < bvolumeslider.getMaximum (); i++)
            blabels.put (new Integer (i), new ColoredComponent (i < bvolumeslider.getMaximum () / 2 ? Color.green : i < bvolumeslider.getMaximum () * 3/4 ? Color.green : Color.red));
        bvolumeslider.setLabelTable (blabels);
      
       bvolumeslider.addChangeListener (new ChangeListener () {
          private int lastValue = 0;
          
          public void stateChanged (ChangeEvent e) {
             if (bvolumeslider.getValue () < lastValue)
                for (int i = bvolumeslider.getValue (); i < lastValue; i++)
                    ((JComponent) blabels.get (new Integer (i))).setOpaque (false);
                else for (int i = lastValue; i < bvolumeslider.getValue (); i++)
                         ((JComponent) blabels.get (new Integer (i))).setOpaque (true);

             lastValue = bvolumeslider.getValue ();
             Switches.Blastervolume = lastValue;
             Settings.set(Settings.DBVOLUME, Util.hex(lastValue));
             bvolumeslider.repaint ();
             }
          });
          
        vslider.setMinimum(0);    //stellt den Minimalwert auf 0 ein
        vslider.setMaximum(90);  //stellt den Maximalwert auf 4 ein
        vslider.setValue(Util.hexValue(Settings.get(Settings.VHOLD, "2D")));
        vslider.setOrientation(JSlider.VERTICAL);    //stellt den Schieberegler horizontal auf
        vslider.setPaintTicks(true);    //Striche werden angezeigt
        vslider.setPaintLabels(false);  //Zahlen werden nicht angezeigt
        vslider.setPaintTrack(true);    //Balken wird angezeigt
        vslider.setSnapToTicks(true);
        vslider.setMajorTickSpacing(5); //Abstände im Großraster
        vslider.setPreferredSize(new Dimension(12, 130));    
        vslider.setBackground(Color.DARK_GRAY);
        vslider.setForeground(new Color(255, 255, 255));
        vslider.setBorder(new EtchedBorder());
              vslider.addChangeListener (new ChangeListener () {
          private int lastValue = 0;
          
          public void stateChanged (ChangeEvent e) {
            lastValue = vslider.getValue ();
             Switches.vhold = lastValue;
             Settings.set(Settings.VHOLD, Util.hex(lastValue));
             vslider.repaint ();
             }
          });
          
        lslider.setMinimum(0);    //stellt den Minimalwert auf 0 ein
        lslider.setMaximum(30);  //stellt den Maximalwert auf 4 ein
        lslider.setValue(0);     //selektiert den Wert von outvolume
        lslider.setOrientation(JSlider.HORIZONTAL);    //stellt den Schieberegler horizontal auf
        lslider.setPaintTicks(false);    //Striche werden angezeigt
        lslider.setPaintLabels(true);  //Zahlen werden nicht angezeigt
        lslider.setPaintTrack(false);    //Balken wird angezeigt
        lslider.setMajorTickSpacing(15); //Abstände im Großraster
        lslider.setPreferredSize(new Dimension(250, 26));    
        lslider.setBackground(Color.GRAY);
        lslider.setForeground(new Color(255, 255, 255));
        lslider.setBorder(new EtchedBorder());
        lslider.setDoubleBuffered(true);
                for (int i = 0; i < lslider.getMaximum (); i++)
            leftlabels.put (new Integer (i), new ColoredComponent (i < lslider.getMaximum () / 2 ? Color.green : i < lslider.getMaximum () * 3/4 ? Color.yellow : Color.red));
            lslider.setLabelTable (leftlabels);
      
        lslider.addChangeListener (new ChangeListener () {
          private int lastValue = 0;
          
          public void stateChanged (ChangeEvent e) {
             if (lslider.getValue () < lastValue)
                for (int i = lslider.getValue (); i < lastValue; i++)
                    ((JComponent) leftlabels.get (new Integer (i))).setOpaque (false);
                else for (int i = lastValue; i < lslider.getValue (); i++)
                         ((JComponent) leftlabels.get (new Integer (i))).setOpaque (true);

             lastValue = lslider.getValue ();
             lslider.repaint ();
             }
          });
        
        rslider.setMinimum(0);    //stellt den Minimalwert auf 0 ein
        rslider.setMaximum(30);  //stellt den Maximalwert auf 4 ein
        rslider.setValue(0);     //selektiert den Wert von outvolume
        rslider.setOrientation(JSlider.HORIZONTAL);    //stellt den Schieberegler horizontal auf
        rslider.setPaintTicks(false);    //Striche werden angezeigt
        rslider.setPaintLabels(true);  //Zahlen werden nicht angezeigt
        rslider.setPaintTrack(false);    //Balken wird angezeigt
        rslider.setMajorTickSpacing(15); //Abstände im Großraster
        rslider.setPreferredSize(new Dimension(250, 26));    
        rslider.setBackground(Color.GRAY);
        rslider.setForeground(new Color(255, 255, 255));
        rslider.setBorder(new EtchedBorder());
        rslider.setDoubleBuffered(true);
                for (int i = 0; i < rslider.getMaximum (); i++)
            rightlabels.put (new Integer (i), new ColoredComponent (i < rslider.getMaximum () / 2 ? Color.green : i < rslider.getMaximum () * 3/4 ? Color.yellow : Color.red));
            rslider.setLabelTable (rightlabels);
      
        rslider.addChangeListener (new ChangeListener () {
          private int lastValue = 0;
          
          public void stateChanged (ChangeEvent e) {
             if (rslider.getValue () < lastValue)
                for (int i = rslider.getValue (); i < lastValue; i++)
                    ((JComponent) rightlabels.get (new Integer (i))).setOpaque (false);
                else for (int i = lastValue; i < rslider.getValue (); i++)
                         ((JComponent) rightlabels.get (new Integer (i))).setOpaque (true);

             lastValue = rslider.getValue ();
             rslider.repaint ();
             }
          });

      mousejoy = Util.getBoolean(getParameter("MOUSEJOY", "false"));
      if (mousejoy == false)
      mousejoy = Settings.getBoolean(Settings.MOUSEJOY, mousejoy);
      if (mousejoy){
          Switches.MouseJoy = true;
          joymouse.setState(true);
      }
      else{
          Switches.MouseJoy = false;
          joymouse.setState(false);
      }
        
      fullscreen = Settings.getBoolean(Settings.FULLSCREEN, false);
      fullscreen = Util.getBoolean(getParameter("FULLSCREEN", Boolean.toString(fullscreen)));
      Switches.effect = Settings.getBoolean(Settings.EFFECT, false);
      effect.setSelected(Switches.effect);
          checkFull.setState(fullscreen);

      Switches.unprotect = Util.getBoolean(getParameter("UNPROTECT", "false"));
      Switches.Printer = Settings.getBoolean(Settings.PRINTER, false);
      Switches.Printer = Util.getBoolean(getParameter("PRINTER", Boolean.toString(Switches.Printer)));
      Switches.Expansion = Settings.getBoolean(Settings.EXPANSION, false);
      Switches.Expansion = Util.getBoolean(getParameter("EXPANSION", Boolean.toString(Switches.Expansion)));
      
      Switches.digiblaster = Settings.getBoolean(Settings.DIGIBLASTER, false);
      Switches.digiblaster = Util.getBoolean(getParameter("DIGIBLASTER", Boolean.toString(Switches.digiblaster)));
      
           unprotect.setState(Switches.unprotect);
           Printer.setState(Switches.Printer);
           Expansion.setState(Switches.Expansion);
           Digiblaster.setState(Switches.digiblaster);
           
      Vhold = Util.getBoolean(getParameter("VHOLD", "false"));
       if (Vhold){
           Switches.vhold = 10;
           vslider.setValue(10);
       }
           
      large = Settings.getBoolean(Settings.LARGE, false);
      large = Util.getBoolean(getParameter("LARGE", Boolean.toString(large)));
      checkGate.setState(large);
  if (large){
      System.out.println("Double size - Gare Array is double");
  }
  else{
          
      System.out.println("Simple size - Gare Array is half");
  }
      
      hideframe = Settings.getBoolean(Settings.HIDEFRAME, false);
      hideframe = Util.getBoolean(getParameter("HIDEFRAME", Boolean.toString(hideframe)));
      
      onTop = Settings.getBoolean(Settings.ONTOP, false);
      onTop = Util.getBoolean(getParameter("ONTOP", Boolean.toString(onTop)));
      aontop.setState(onTop);
      
      this.fsound = Settings.getBoolean(Settings.FLOPPYSOUND, true);
      this.fsound = Util.getBoolean(getParameter("FLOPPYSOUND", Boolean.toString(this.fsound)));
          drivesound.setState(fsound);
      this.notebook = Settings.getBoolean(Settings.NOTEBOOK, false);
      this.notebook = Util.getBoolean(getParameter("NOTEBOOK", Boolean.toString(this.notebook)));
      qaop.setState(notebook);

      final boolean alternativejoy = Util.getBoolean(getParameter("ALTJOY", "false"));

      final boolean debug = Util.getBoolean(getParameter("DEBUG", "false"));

      final boolean pause = Util.getBoolean(getParameter("PAUSE", "false"));
       
      this.joystick = Settings.getBoolean(Settings.JOYSTICK, true);
      this.joystick = Util.getBoolean(getParameter("JOYSTICK", Boolean.toString(joystick)));
      joyemu.setState(joystick);
          qaop.setEnabled(joystick);
      final boolean status = Util.getBoolean(getParameter("STATUS", "false"));
      if(status)
          addStatus();
      boolean audioon = Settings.getBoolean(Settings.AUDIO, true);
      audioon = Util.getBoolean(getParameter("AUDIO", Boolean.toString(audioon)));
      autosave = Settings.getBoolean(Settings.AUTOSAVE, false);
      autosave = Util.getBoolean(getParameter("AUTOSAVE", Boolean.toString(autosave)));
      Switches.autosave = autosave;
      autosavedsk.setState(autosave);
      
      Switches.ScanLines = Settings.getBoolean(Settings.SCANLINES, false);
      Switches.ScanLines = Util.getBoolean(getParameter("SCANLINES", Boolean.toString(Switches.ScanLines)));
      checkScan.setState(Switches.ScanLines);
      
      if (executable){
         /* selector = false;
          buttons=false;
          border=false;*/
      frame.setMenuBar(JavaCPCMenu);      
      showmenu = true;
      }
      //  manual ROM settings
      // in progress
      
      Switches.LOWER = Settings.get(Settings.LOWER, "OS464.zip");
      Switches.UPPER_0 = Settings.get(Settings.UPPER_0, "BASIC1-0.zip");
      Switches.UPPER_1 = Settings.get(Settings.UPPER_1, "none");
      Switches.UPPER_2 = Settings.get(Settings.UPPER_2, "none");
      Switches.UPPER_3 = Settings.get(Settings.UPPER_3, "none");
      Switches.UPPER_4 = Settings.get(Settings.UPPER_4, "none");
      Switches.UPPER_5 = Settings.get(Settings.UPPER_5, "none");
      Switches.UPPER_6 = Settings.get(Settings.UPPER_6, "none");
      Switches.UPPER_7 = Settings.get(Settings.UPPER_7, "none");
      Switches.UPPER_8 = Settings.get(Settings.UPPER_8, "none");
      Switches.UPPER_9 = Settings.get(Settings.UPPER_9, "none");
      Switches.UPPER_A = Settings.get(Settings.UPPER_A, "none");
      Switches.UPPER_B = Settings.get(Settings.UPPER_B, "none");
      Switches.UPPER_C = Settings.get(Settings.UPPER_C, "none");
      Switches.UPPER_D = Settings.get(Settings.UPPER_D, "none");
      Switches.UPPER_E = Settings.get(Settings.UPPER_E, "none");
      Switches.UPPER_F = Settings.get(Settings.UPPER_F, "none");
      
      StoreRoms();
      
      this.MachineMemory = getParameter("MEMORY", "512");
      if (MachineMemory.equals("512"))
          Switches.Memory = "TYPE_512K";
      if (MachineMemory.equals("256"))
          Switches.Memory = "TYPE_256K";
      if (MachineMemory.equals("128"))
          Switches.Memory = "TYPE_128K";
      if (MachineMemory.equals("64"))
          Switches.Memory = "TYPE_64K";
      if (MachineMemory.equals("SILICON"))
          Switches.Memory = "TYPE_SILICON_DISC";
      
      showonlinemenu = Util.getBoolean(getParameter("MENU","false"));
      autoboot = Util.getBoolean(getParameter("AUTOBOOT","false"));
      osd = Settings.getBoolean(Settings.OSD, true);
      osd = Util.getBoolean(getParameter("OSD", Boolean.toString(osd)));
      osdisplay.setState(osd);
      discb = getParameter("DISCB", null);
      discb = getParameter("DISKB", discb);
      discc = getParameter("DISCC", null);
      discc = getParameter("DISKC", discc);
      discd = getParameter("DISCD", null);
      discd = getParameter("DISKD", discd);
      autostartProg = getParameter("FILE", null);
      autostartDisk = getParameter("DISC", null);
      autostartDisk = getParameter("DISK", autostartDisk);
 
      mon = Settings.get(Settings.MONITOR, "COLOR");
      Monitor = getParameter("MONITOR", mon);
      
      if (computer == null) {
  
    final String ComputerSystem = Settings.get(Settings.SYSTEM, "CPC6128");
    if (ComputerSystem.equals("CPC464"))
        cpc464.setState(true);
    if (ComputerSystem.equals("CPC664"))
        cpc664.setState(true);
    if (ComputerSystem.equals("CPC6128"))
        cpc6128.setState(true);
    if (ComputerSystem.equals("CUSTOM"))
        customcpc.setState(true);
    setComputers = getParameter("COMPUTER", null);
    
    
    if (osd){

        Switches.osddisplay = true;
    }
    else{
        Switches.osddisplay = false;       
    }
    
    if (setComputers != null){
        setComputer(setComputers, !(debug || pause));
      }
    else{  
        if (ComputerSystem != null) {
        setComputer((ComputerSystem), !(debug || pause));
    }
        else{
        setComputers = getParameter("COMPUTER" ,Computer.DEFAULT_COMPUTER);
        setComputer(setComputers, !(debug || pause));
    }}
      } else if (!(debug || pause)) {
        computer.start();
      }

      System.out.println("DEBUG=" + debug + ", PAUSE=" + pause + ", LARGE=" + large);

      System.out.println("System Set: " + computer);
    Display.model = "" + computer;
    Display.showmodel = 100;
      
    
      if (autostartDisk != null) {
        if (autostartProg != null) {
        } else {
          pauseComputer();
          autoload = 4;
          loadFile(autostartDisk);
          goComputer();
        }
      }

      if (autostartProg != null) {
        if (autostartDisk != null) {
          autoload = 4;
          Display.loadgames = 100;
        } else {
          autoload = 4;
          pauseComputer();
          loadFile(autostartProg);
          goComputer();
        }
      }

      if (discb != null) {
        if (autostartProg == null) {
          computer.setCurrentDrive(1);
          loadFile(discb);
          computer.setCurrentDrive(0);
        }
      }
      if (discc != null) {
        if (autostartProg == null) {
          computer.setCurrentDrive(2);
          loadFile(discc);
          computer.setCurrentDrive(0);
        }
      }
      
      if (discd != null) {
        if (autostartProg == null) {
          computer.setCurrentDrive(3);
          loadFile(discd);
          computer.setCurrentDrive(0);
        }
      }

      if (Monitor != null) {
        {
            if (Monitor.equals("JEMU")) {
            Switches.monitormode = 1;
            checkJColor.setState(true);
            Display.monmessage = "Colour 32 INKs";
          }
        }
        {
          if (Monitor.equals("COLOUR")) {
            Switches.monitormode = 0;
            checkColor.setState(true);
            Display.monmessage = "Colour monitor";
          }
        }
        {
          if (Monitor.equals("COLOR")) {
            Switches.monitormode = 0;
            checkColor.setState(true);
            Display.monmessage = "Colour monitor";
          }
        }
        {
          if (Monitor.equals("GREEN")) {
            Switches.monitormode = 2;
            checkGreen.setState(true);
            Display.monmessage = "Green monitor";
          }
        }
        {
          if (Monitor.equals("GREY")) {
            Switches.monitormode = 3;
            checkGrey.setState(true);
            Display.monmessage = "Grey monitor";
          }
        }
        {
          if (Monitor.equals("GRAY")) {
            Switches.monitormode = 3;
            checkGrey.setState(true);
            Display.monmessage = "Grey monitor";
          }

        }
      }

      if (audioon) {
        Switches.audioenabler = 1;
        checkAudio.setState(true);
        System.out.println("Audio Enabled");
      } else {
        Switches.audioenabler = 0;
        checkAudio.setState(false);
        System.out.println("Audio Disabled");
      }

    fsoundInit();
      
      if (notebook) {
        Switches.notebook = true;
        System.out.println("Notebook Enabled");
      } else {
        Switches.notebook = false;
        System.out.println("Notebook Disabled");
      }      
      
      if (alternativejoy)
          Switches.notebook = true;
      
      if (autosave) {
          Switches.autosave = true;
        System.out.println("Autosave Enabled");
      } else {
          Switches.autosave = false;
        System.out.println("Autosave Disabled");
      }     
      
        if (autoboot)
            autobooter = 1;
        else
            autobooter = 0;
 
      if (joystick) {
        Switches.joystick = 1;
      } else {
        Switches.joystick = 0;
      }
    

     /*          for (int i = 0; i < Computer.COMPUTERS.length; i++) {
                final ComputerDescriptor desc = Computer.COMPUTERS[i];
                    if (desc.shown) {
                    this.jcbComputer.addItem(desc);
                    if (computer.getName().equalsIgnoreCase(desc.key)) {
                    this.jcbComputer.setSelectedIndex(this.jcbComputer.getItemCount() - 1);
                }
                    }
                          }
    
        this.jcbComputer.addItemListener(this);
        this.jcbComputer.setFocusable(false);
        this.jcbImage.addItemListener(this);
        this.jcbImage.setFocusable(false);*/
        this.jcbDrive.addItemListener(this);
        this.jcbDrive.setFocusable(false);
        this.driveHead.addItemListener(this);
        this.driveHead.setFocusable(false);
        
   /* jcbComputer.setFont(font);
    jcbImage.setFont(font);*/
 /* 

    */
    
    
    if (Monitoruppanel != null)
          add (Monitoruppanel,  BorderLayout.NORTH);
      if (Monitordownpanel != null)
          add (Monitordownpanel,  BorderLayout.SOUTH);
      if (Monitorleftpanel != null)
          add (Monitorleftpanel,  BorderLayout.WEST);
      if (Monitorrightpanel != null)
          add (Monitorrightpanel,  BorderLayout.EAST);

      if (debug) {
        showDebugger();
      }
      this.started = true;
    } catch (final Exception e) {
      e.printStackTrace();
    }
        Display.automessage = "JavaCPC started...";
        Display.showauto = 150; 
    if (executable)        
    if (hideframe){
    hideFrame();
    }
       
    SetMenu();
    if (showonlinemenu)
        OnlineMenu();
    
      if (!executable){
    checkFull.setEnabled(false);
    checkTriple.setEnabled(false);
    checkDouble.setEnabled(false);
    checkGate.setEnabled(false);
    aontop.setEnabled(false);
         // Switches.doublesize = false;
         // Switches.triplesize = false;
      }
    checkDouble.setState(Switches.doublesize);
    checkTriple.setState(Switches.triplesize);
    
      if (Util.getBoolean(getParameter("OPTIONS", "false")) == true)
          OptionPanel();
  }

  public boolean isStarted() {
    return started;
  }

  public void waitStart() {
    try {
      while (!started)
        Thread.sleep(10);
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  public void focusDisplay() {
    display.requestFocus();
  }

  public void run() {
  }

  public void startComputer() {
    Display.showpause = 0;
    computer.start();

  }

  
  public void destroy() {
  }

    public void osdCheck(){
    if (osd){        
        osd = false;
        Settings.setBoolean(Settings.OSD, false);
        Switches.osddisplay = false;
    }
    else{   
        osd = true;
        Settings.setBoolean(Settings.OSD, true);
        Switches.osddisplay = true;
    }
  }
   
  public String getAppletInfo() {
    return "Applet Information";
  }

   
  public String[][] getParameterInfo() {
    return null;
  }

  public static void main(String[] args) {  
    JEMU applet = new JEMU();
    applet.isStandalone = true; 
    
    frame = new JFrame() {
        
      
      protected void processWindowEvent(WindowEvent we) {
        super.processWindowEvent(we);
        if (we.getID() == WindowEvent.WINDOW_CLOSING) {
            Autotype.save();
          System.exit(0);
        }
      }

      public synchronized void setTitle(String title) {
        super.setTitle(title);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      }

    };
    frame.setTitle("JavaCPC by Devilmarkus [Based on JEMU] - X-mas edition");
    frame.getContentPane().add(applet, BorderLayout.CENTER);
    frame.setFocusable(false);
    applet.init();
    applet.start();
    turnOn.play();
    frame.pack();
    final Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    winx1 = frame.getSize().width;
    winy1 = frame.getSize().height;
    System.out.println("Window is "+ winx1 + " Pixels with & " + winy1 + " Pixels height!");
    if (onTop){
        frame.setAlwaysOnTop(true);
        Switches.top = 1;
        Settings.setBoolean(Settings.ONTOP, true);
    }
    else{
        Switches.top = 0;
        frame.setAlwaysOnTop(false);
    
        Settings.setBoolean(Settings.ONTOP, false);
    }
                Switches.stretch = 1;
    if (fullscreen){
        togglesize = false;
        frame.dispose();
        frame.setUndecorated(true);
        frame.setSize(d);
      frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    }                 
    frame.setVisible(true); 
  }
  
  public static void External(){
        JEMU applet = new JEMU();
    applet.isStandalone = true; 
    
    frame = new JFrame() {
        
      
      protected void processWindowEvent(WindowEvent we) {
        super.processWindowEvent(we);
        if (we.getID() == WindowEvent.WINDOW_CLOSING) {
          System.exit(0);
        }
      }

      public synchronized void setTitle(String title) {
        super.setTitle(title);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      }

    };
    frame.setTitle("JavaCPC by Devilmarkus [Based on JEMU]");
    frame.getContentPane().add(applet, BorderLayout.CENTER);
    frame.setFocusable(false);
    applet.init();
    applet.start();
    turnOn.play();
    frame.pack();
    final Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    winx1 = frame.getSize().width;
    winy1 = frame.getSize().height;
    System.out.println("Window is "+ winx1 + " Pixels with & " + winy1 + " Pixels height!");
    if (onTop){
        frame.setAlwaysOnTop(true);
        Switches.top = 1;
        Settings.setBoolean(Settings.ONTOP, true);
    }
    else{
        Switches.top = 0;
        frame.setAlwaysOnTop(false);
    
        Settings.setBoolean(Settings.ONTOP, false);
    }
                Switches.stretch = 1;
    if (fullscreen){
        togglesize = false;
        frame.dispose();
        frame.setUndecorated(true);
        frame.setSize(d);
      frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    }
                
                
                         
    frame.setVisible(true); 
  }

  public void update(Graphics g) {
    paint(g); 
    if (screenshottimer !=0){
        screenshottimer++;
        if (screenshottimer==16){
            screenshot();
            screenshottimer = 0;
        }
    }  
    if (screentimer !=0){
        screentimer++;
        if (screentimer==50){
            screenshot();
            screenshottimer = 0;
        }
    } 
    if (dsksavetimer !=0){
        dsksavetimer++;
        if (dsksavetimer==6)
            saveDsk();
    }
    if (dskmaketimer !=0){
        dskmaketimer++;
        if (dskmaketimer==6)
            CreateDsk();
    }
    if (loadtimer !=0){
        loadtimer++;
                if (loadtimer == 10){
                    loaddata();
                    loadtimer = 0;
                }
    }
    
    if (loadprogtimer !=0){
        Display.loadtimer = 1;
        Switches.osddisplay = false;
        loadprogtimer++;
                if (loadprogtimer == 60){
                    loadprogtimer = 0;
                    computer.AutoType();
                    Display.loadtimer = 0;
                    Switches.osddisplay = osd;
                }
                    
    }
    
    if (simpletimer !=0){
        simpletimer ++;
        if (simpletimer == 2){
          System.out.println("SimpleBoot active. Trying to boot "+DSKfile);
          loadFile(DSKfile+".dsk");
          loadFile(DSKfile+".zip");
          simpletimer = 0;
        }
    }

    Switches.volume = volumeslider.getValue();
    if (Switches.volume != checkvolume){
      if (Switches.volume == 4){        
          compvolume = "4";}
      if (Switches.volume == 3){
          compvolume = "3";}
      if (Switches.volume == 2){
          compvolume = "2";}
      if (Switches.volume == 1){
          compvolume = "1";}
      if (Switches.volume == 0){
          compvolume = "0";}
        Settings.set(Settings.VOLUME, compvolume);}
    checkvolume = Switches.volume;
    Switches.volume = 15 + (4 - Switches.volume);
    
    autoLoad();
    if (pausetimer != 0){
        pausetimer = 0;                
        pauseComputer();
    }
    
    if (autobooter != 0){
        if (autobooter == 1)
        Display.showboot = 120;
        Switches.luminance = 0;
        autobooter = autobooter + 1;
        if (autobooter == 50){
            reset();
        }
        if (autobooter == 80){
            reset();
        }
        if (autobooter >= 120){
            autobooter = 0;
            Switches.booter = 1;
            autoBoot();
        }
    }else{
    Switches.luminance = lslider.getValue();
    
    }       
    
    if (dtimer ==1){           
        display.requestFocus();
        dtimer = 0;
    }
  }

  public void autoBoot() {
      computer.reset();
      System.out.print("Trying to autoboot " + compsys);
      if (compsys.equals("CPC664"))
          loadFile("autoboot664.sna");
      else
      if (compsys.equals("CPC464"))
          loadFile("autoboot464.sna");
      else
      if (compsys.equals("CPC464PARA"))
          loadFile("autoboot464.sna");
      else
          loadFile("autoboot.sna");
      
      
      Switches.booter = 0;
  }
  
 private void autoLoad() {
    if (autoloader == 1) {
      autoloader = 0;
      pauseComputer();
      loadFile(autostartProg);
      autostartProg = null;
      autoload = 4;
      goComputer();
    } else if (autoloader == 2) {
        autoloader = 0;
      pauseComputer();
      loadFile(autostartDisk);
      autostartDisk = null;
      autoload = 4;
      if (discb != null) {
        computer.setCurrentDrive(1);
        loadFile(discb);
        computer.setCurrentDrive(0);
      }
      goComputer();
    } else if (autoload == 0) {
        autoload = 5;
      pauseComputer();
      LoadFiles();
      goComputer();
    }
  }
  
  public void LoadFiles(){
      // load drives from settings
      int numOfDrives = computer.getFloppyDrives() == null ? 0 : computer.getFloppyDrives().length;
      for (int i = 0; i < numOfDrives; i++) {
        final String fileName = Settings.get(Settings.DRIVE_FILE + Integer.toString(i), null);
        final boolean loaddrive = Settings.getBoolean(Settings.LOADDRIVE + Integer.toString(i), false);
        if (loaddrive == true){
        if (fileName != null) {
              System.out.println("auto load drive " + i + ": " + "*" + fileName + "*");
              computer.setCurrentDrive(i);
              loadFile(Computer.TYPE_UNKNOWN, fileName, false);            
        }}
        computer.setCurrentDrive(0);
      }
  }
  
  public void CreateDsk(){
        if (executable)
     frame.setAlwaysOnTop(false);
           
        if (executable)
      frame.setAlwaysOnTop(onTop);
      if (Switches.floppysound)
        flopsound = 1;
      Switches.floppysound = false;
      loadFile("blankdisk.dsk");
      if (flopsound == 1)
          Switches.floppysound = true;
      flopsound = 0;
      saveDsk();
            
        if (executable)
   frame.setAlwaysOnTop(onTop);

  }

  public void keyTyped(KeyEvent e) { }

  public void keyPressed(KeyEvent e) {
      //
      // ** locale settings **
      //
    //System.out.println(Util.hex(e.getKeyCode()));
      
    // german keyboard mapping
      if (localkeys.equals("DE_DE")){
          if (!keys.equals("German keyboard  ")){
          keys = "German keyboard  ";
          Keys.setLabel(keys);
          }
    if (e.getKeyChar() == 'ü' || e.getKeyChar() == 'Ü')
        e.setKeyCode(KeyEvent.VK_OPEN_BRACKET);
    if (e.getKeyChar() == 'ä' || e.getKeyChar() == 'Ä')
        e.setKeyCode(KeyEvent.VK_QUOTE);
    if (e.getKeyChar() == 'ö' || e.getKeyChar() == 'Ö')
        e.setKeyCode(KeyEvent.VK_SEMICOLON);
    if (e.getKeyChar() == 'ß' || e.getKeyChar() == '?')
        e.setKeyCode(KeyEvent.VK_MINUS);
    else
    if (e.getKeyCode() == 0x2d)                             // - key to /
        e.setKeyCode(KeyEvent.VK_SLASH);
    
    if (e.getKeyCode() == 0x81)                             // ´ key to ^
        e.setKeyCode(KeyEvent.VK_EQUALS);
    if (e.getKeyCode() == 0x99)                             // <> key to [
        e.setKeyCode(KeyEvent.VK_ALT_GRAPH);
    if (e.getKeyCode() == 0x82)                             // ^ key to TAB
        e.setKeyCode(KeyEvent.VK_TAB);
    if (e.getKeyCode() == 0x208)                            // # key to \
        e.setKeyCode(KeyEvent.VK_BACK_SLASH);
    if (e.getKeyCode() == 0x209)                            // + key to ]
        e.setKeyCode(KeyEvent.VK_CLOSE_BRACKET);
    
    if (e.getKeyCode() == KeyEvent.VK_Z)                    // change Z to Y
        e.setKeyCode(KeyEvent.VK_Y);
    else
    if (e.getKeyCode() == KeyEvent.VK_Y)                    // and Y to Z
        e.setKeyCode(KeyEvent.VK_Z);
      }
    // german mapping end
  
    // spanish keyboard mapping
      if (localkeys.equals("ES_ES")){
          if (!keys.equals("Spanish keyboard  ")){
          keys = "Spanish keyboard  ";
          Keys.setLabel(keys);
          }
    if (e.getKeyChar() == 'º' || e.getKeyChar() == 'ª')
        e.setKeyCode(KeyEvent.VK_TAB);
    if (e.getKeyChar() == 'ç' || e.getKeyChar() == 'Ç')
        e.setKeyCode(KeyEvent.VK_BACK_SLASH);
    
    if (e.getKeyChar() == 'ñ' || e.getKeyChar() == 'Ñ')
        e.setKeyCode(KeyEvent.VK_SEMICOLON);
    else
    if (e.getKeyCode() == 0xde) 
        e.setKeyCode(KeyEvent.VK_MINUS);
    else
    if (e.getKeyCode() == 0x2d)                             // - key to /
        e.setKeyCode(KeyEvent.VK_SLASH);
    else
    if (e.getKeyCode() == 0x81)
        e.setKeyCode(KeyEvent.VK_QUOTE);
    if (e.getKeyCode() == 0x209)                            // + key to ]
        e.setKeyCode(KeyEvent.VK_CLOSE_BRACKET);
    
    if (e.getKeyCode() == 0x206)
        e.setKeyCode(KeyEvent.VK_EQUALS);
    if (e.getKeyCode() == 0x99)
        e.setKeyCode(KeyEvent.VK_ALT_GRAPH);
    if (e.getKeyCode() == 0x80)
        e.setKeyCode(KeyEvent.VK_OPEN_BRACKET);
      }
    // spanish mapping end 
  
    if (e.getKeyCode() == KeyEvent.VK_CONTROL){
        ctrl = true;
    }
    
    if (e.getKeyCode() == KeyEvent.VK_PAGE_DOWN){
        mediumeject();
    }
    
    if (e.getKeyCode() == KeyEvent.VK_PAGE_UP){
        loaddata();
    }
    
    if (e.getKeyCode() == KeyEvent.VK_SCROLL_LOCK) {
        autosavecheck();
    }
    if (e.getKeyCode() == KeyEvent.VK_PAUSE) {
        pausecheck();
    }
    if (e.getKeyCode() == KeyEvent.VK_HOME)
    setRoms();
    
      if (e.getKeyCode() == KeyEvent.VK_F9) {
        if(ctrl)         
        computer.reset();
      }
      if (e.getKeyCode() == KeyEvent.VK_F11) {
        if(ctrl){
        ctrl = false; 
        screenshot();
        }
        else
        Autotype.PasteText();
      }

      if (e.getKeyCode() == 107) {
        if (executable)
      frame.setAlwaysOnTop(false);
      saveDsk();
        if (executable)
      frame.setAlwaysOnTop(onTop);
      }
      
    if (executable){
        //if (skinned != true){
      if (e.getKeyCode() == KeyEvent.VK_F10) {
          if (ctrl)
              if (Options == false)
          OptionPanel();
      }
      if (e.getKeyCode() == KeyEvent.VK_F12) {
          if (ctrl)
          MenuCheck();
      }

      if (e.getKeyCode() == KeyEvent.VK_DIVIDE) {
        Size();
      }
      if (e.getKeyCode() == KeyEvent.VK_MULTIPLY) {
        FullSize();
      }
      if (e.getKeyCode() == 109) {
        //defaultSize();
          if (sizecounter == 0){
        if (skinned){
            Moniup.setVisible(false);
            Monidown.setVisible(false);
            Monileft.setVisible(false);
            Moniright.setVisible(false);
        }
              sizecounter++;
              Switches.doublesize=true;
              Switches.triplesize=false;
          fullscreen = false;
              Settings.setBoolean(Settings.TRIPLE, false);
              Settings.setBoolean(Settings.DOUBLE, true);
              
      if (!executable){
          Switches.doublesize = false;
          Switches.triplesize = false;
      }
          }else 
          if (sizecounter == 1){
        if (skinned){
            Moniup.setVisible(false);
            Monidown.setVisible(false);
            Monileft.setVisible(false);
            Moniright.setVisible(false);
        }
              sizecounter++;
              Switches.doublesize=false;
              Switches.triplesize=true;
          fullscreen = false;
              Settings.setBoolean(Settings.TRIPLE, true);
              Settings.setBoolean(Settings.DOUBLE, false);
              
      if (!executable){
          Switches.doublesize = false;
          Switches.triplesize = false;
      }
          }else
          if (sizecounter == 2){
              
        if (skinned){
            if(!large){
            Moniup.setVisible(false);
            Monidown.setVisible(false);
            Monileft.setVisible(false);
            Moniright.setVisible(false);
            }
        }
              sizecounter = 0;
              Switches.doublesize=false;
              Switches.triplesize=false;
          fullscreen = false;
              Settings.setBoolean(Settings.TRIPLE, false);
              Settings.setBoolean(Settings.DOUBLE, false);
              
      if (!executable){
          Switches.doublesize = false;
          Switches.triplesize = false;
      }
          }
          defaultSize();
      }
    }
    computer.processKeyEvent(e);
  }

  public void keyReleased(KeyEvent e) {
      //
      // ** locale settings **
      //
    //System.out.println(Util.hex(e.getKeyCode()));
      
    // german keyboard mapping
      if (localkeys.equals("DE_DE")){
    if (e.getKeyChar() == 'ü' || e.getKeyChar() == 'Ü')
        e.setKeyCode(KeyEvent.VK_OPEN_BRACKET);
    if (e.getKeyChar() == 'ä' || e.getKeyChar() == 'Ä')
        e.setKeyCode(KeyEvent.VK_QUOTE);
    if (e.getKeyChar() == 'ö' || e.getKeyChar() == 'Ö')
        e.setKeyCode(KeyEvent.VK_SEMICOLON);
    if (e.getKeyChar() == 'ß' || e.getKeyChar() == '?')
        e.setKeyCode(KeyEvent.VK_MINUS);
    else
    if (e.getKeyCode() == 0x2d)                             // - key to /
        e.setKeyCode(KeyEvent.VK_SLASH);
    
    if (e.getKeyCode() == 0x81)                             // ´ key to ^
        e.setKeyCode(KeyEvent.VK_EQUALS);
    if (e.getKeyCode() == 0x99)                             // <> key to [
        e.setKeyCode(KeyEvent.VK_ALT_GRAPH);
    if (e.getKeyCode() == 0x82)                             // ^ key to TAB
        e.setKeyCode(KeyEvent.VK_TAB);
    if (e.getKeyCode() == 0x208)                            // # key to \
        e.setKeyCode(KeyEvent.VK_BACK_SLASH);
    if (e.getKeyCode() == 0x209)                            // + key to ]
        e.setKeyCode(KeyEvent.VK_CLOSE_BRACKET);
    
    if (e.getKeyCode() == KeyEvent.VK_Z)                    // change Z to Y
        e.setKeyCode(KeyEvent.VK_Y);
    else
    if (e.getKeyCode() == KeyEvent.VK_Y)                    // and Y to Z
        e.setKeyCode(KeyEvent.VK_Z);
      }
    // german mapping end
  
    // spanish keyboard mapping
      if (localkeys.equals("ES_ES")){
    if (e.getKeyChar() == 'º' || e.getKeyChar() == 'ª')
        e.setKeyCode(KeyEvent.VK_TAB);
    if (e.getKeyChar() == 'ç' || e.getKeyChar() == 'Ç')
        e.setKeyCode(KeyEvent.VK_BACK_SLASH);
    
    if (e.getKeyChar() == 'ñ' || e.getKeyChar() == 'Ñ')
        e.setKeyCode(KeyEvent.VK_SEMICOLON);
    else
    if (e.getKeyCode() == 0xde) 
        e.setKeyCode(KeyEvent.VK_MINUS);
    else
    if (e.getKeyCode() == 0x2d)                             // - key to /
        e.setKeyCode(KeyEvent.VK_SLASH);
    else
    if (e.getKeyCode() == 0x81)
        e.setKeyCode(KeyEvent.VK_QUOTE);
    if (e.getKeyCode() == 0x209)                            // + key to ]
        e.setKeyCode(KeyEvent.VK_CLOSE_BRACKET);
    
    if (e.getKeyCode() == 0x206)
        e.setKeyCode(KeyEvent.VK_EQUALS);
    if (e.getKeyCode() == 0x99)
        e.setKeyCode(KeyEvent.VK_ALT_GRAPH);
    if (e.getKeyCode() == 0x80)
        e.setKeyCode(KeyEvent.VK_OPEN_BRACKET);
      }
    // spanish mapping end 
  
    computer.processKeyEvent(e);
    if (e.getKeyCode() == KeyEvent.VK_CONTROL)
        ctrl = false;
  }

  public void mouseClicked(MouseEvent e) {
 
      if (mousejoy == false){
          if (e.getClickCount() == 2) {
          if ((e.getModifiers() & MouseEvent.BUTTON1_MASK) != 0) {
              //new Autotype();
        Autotype.typeconsole.setVisible(true);
          } else 
              MenuCheck();
      }
  }
  }

  public void MenuCheck(){
          if (executable){
                //frame.dispose();
                if (showmenu){
                    showmenu = false;
                    frame.remove(JavaCPCMenu);
                    Settings.setBoolean(Settings.showmenu, false);
          
                } else {
                    showmenu = true;
                    frame.setMenuBar(JavaCPCMenu);
                    Settings.setBoolean(Settings.showmenu, true);
          
                }
                frame.pack();
                //frame.setVisible(true);
                display.requestFocus();
                } 
          else {
          if (showmenu == false){
              showmenu = true;
              OnlineMenu();
          } else {
              showmenu = false;
              onlinemenu.dispose();
          }
                
          }
  }
  public void mousePressed(MouseEvent e) {
      if (mousejoy){
      if ((e.getModifiers() & MouseEvent.BUTTON1_MASK) != 0) 
       computer.MouseFire1();
       else   
       computer.MouseFire2();      
      }
    display.requestFocus();
  }

  public void mouseReleased(MouseEvent e) {
      if (mousejoy){
      if ((e.getModifiers() & MouseEvent.BUTTON1_MASK) != 0)
       computer.MouseReleaseFire1();
       else  
       computer.MouseReleaseFire2();
      }
  }

  public void mouseEntered(MouseEvent e) {
  }

  public void mouseExited(MouseEvent e) { }

  public void showDebugger() {
      Switches.showPalette = true;
    try {
      System.out.println("showDebugger");
      if (debugger == null) {
        this.debugger = (Debugger) Util.secureConstructor(Debugger.class, new Class[] {}, new Object[] {});
        this.debugger.setBounds(0, 0, 640, 480);
        debugger.setComputer(computer);
      }
      System.out.println("Showing Debugger");
      debugger.setVisible(true);
      debugger.toFront();
    } catch(Exception e) {
      e.printStackTrace();
    }
  }

  public Computer getComputer() {
    return computer;
  }
  
  public String loadFile(String name) {
    return loadFile(Computer.TYPE_UNKNOWN, name, true);
  }
 

  public String loadFile(int type, String name, boolean usePath) {
   Status2.setText(name);
    String result = null;
    try {
      boolean running = computer.isRunning();
      computer.stop();
      try {
        final String fileName = (usePath ? computer.getFilePath() : "") + name;
        computer.loadFile(type, fileName);
        result = computer.getFileInfo(name);

        Switches.loadname = name;

        Display.showdisk = 150;

        if (Switches.booter == 0){
          Settings.set(Settings.DRIVE_FILE + Integer.toString(computer.getCurrentDrive()), fileName);
          Settings.setBoolean(Settings.LOADDRIVE + Integer.toString(computer.getCurrentDrive()), true);
        }
        
      } finally {
        display.requestFocus();
        if (running)
          computer.start();
      }
    } catch(Exception e) {
      e.printStackTrace();
    }
    return result;
  }



  public void resetComputer() {
    computer.reset();
    Display.showpause = 0;
    computer.start();
    computer.reset();
    Display.showpause = 0;
    computer.start();
  }
  
  public void rebootComputer() {
    computer.reset();
    Display.showpause = 0;
    computer.start();
    reBoot();
  }

  public void ejectComputer() {
    computer.eject();
  }

  public void goComputer() {
    Display.showpause = 0;
    computer.start();
  }

  public void stopComputer() {
      Display.showpause = 4;
      pausetimer = 1;
  }

  public void pauseComputer() {
    computer.stop();
  }
  
  public void fsoundcheck(){    
      if (fsound == false) {
        Switches.floppysound = true;
        Settings.setBoolean(Settings.FLOPPYSOUND, true);
        System.out.println("Floppysound Enabled");
        Display.automessage = "Floppy sound emulation is ON";
        Display.showauto = 150; 
        drivesound.setState(true);
        fsound = true;
      } else {
        Switches.floppysound = false; 
        Settings.setBoolean(Settings.FLOPPYSOUND, false);
        System.out.println("Floppysound Disabled");
        Display.automessage = "Floppy sound emulation is OFF";
        Display.showauto = 150; 
        drivesound.setState(false);
        fsound = false;
      }
      
  }  public void nbcheck(){
      
      if (notebook == false) {
        Switches.notebook = true;  
        Settings.setBoolean(Settings.NOTEBOOK, true);
        System.out.println("Notebook Enabled");
        System.out.println("W, A, S, D = Direction-control, O, P = Firebutton 1,2");
        Display.automessage = "Notebook is ON";
        Display.showauto = 150; 
        notebook = true;
      } else {
        Switches.notebook = false;  
        Settings.setBoolean(Settings.NOTEBOOK, false);
        System.out.println("Notebook Disabled");
        Display.automessage = "Notebook is OFF";
        Display.showauto = 150; 
        notebook = false;
      }
  }
  
  public void pausecheck(){
       if (paused == 0) {
        paused = 1;
        stopComputer();
        System.out.println("System halted");
      } else {
        paused = 0;
        goComputer();
        System.out.println("System started");
      }
  }
  
  public void info(){
        paused = 1;
        stopComputer();
        System.out.println("System halted");
        message();
        paused = 0;
        goComputer();
        System.out.println("System started");
  }
  
  public void joycheck(){
      
      if (Switches.joystick == 1) {
        Switches.joystick = 0;
        Settings.setBoolean(Settings.JOYSTICK, false);
          System.out.println("Joystick emulation disabled");
        Display.automessage = "Joystick is OFF";
        Display.showauto = 150;
      } else {
        Switches.joystick = 1;
        Settings.setBoolean(Settings.JOYSTICK, true);
        Display.automessage = "Joystick is ON";
        Display.showauto = 150;
          System.out.println("Joystick emulation enabled\nuse seperate number-block with NUM-Lock on\n4, 8, 6, 2 - directions, 5, 0 - fire-buttons");
      }
  }
  
  public void audiocheck(){
      
      if (Switches.audioenabler == 0) {
        Switches.audioenabler = 1;
        System.out.println("Audio Enabled");
        Settings.setBoolean(Settings.AUDIO, true);
        Display.automessage = "Audio enabled";
        Display.showauto = 150;

        this.display.requestFocus();
      } else {
        if (Switches.audioenabler == 1) {
          Switches.audioenabler = 0;
          System.out.println("Audio Disabled");
          Settings.setBoolean(Settings.AUDIO, false);
        Display.automessage = "Audio disabled";
        Display.showauto = 150;

          this.display.requestFocus();
        }

      }
  }
  
  public void dskmerge(){
         jemu.system.cpc.CPCDiscImageMerger.merge();
  }
  
  public void autosavecheck(){
      if (autosave) {
        System.out.println("Autosave Disabled");        
        Settings.setBoolean(Settings.AUTOSAVE, false);
        Display.automessage = "Autosave is OFF";
        Display.showauto = 150;
        autosave = false;
        Switches.autosave = false;
      } else {
        System.out.println("Autosave Enabled");
        Settings.setBoolean(Settings.AUTOSAVE, true);
        Display.automessage = "Autosave is ON";
        Display.showauto = 150;
        autosave = true;
        Switches.autosave = true;
      }
  }  
  
  public void alwaysOnTopCheck(){
              if (Switches.top == 0){
            Switches.top = 1;
        Settings.setBoolean(Settings.ONTOP, true);
        if (executable)
            frame.setAlwaysOnTop(true);}
        else{
            Switches.top = 0;
        if (executable)
            frame.setAlwaysOnTop(false);
        }
  }
  
    public void autobootcheck(){
        autobooter = 1;
  } 
  
  public void reset(){   
      computer.reset();
      Display.showdisk = 150;
      this.display.requestFocus();
  }
  
  public void mediumeject(){
      computer.eject();
    //  this.jcbImage.setSelectedIndex(-1);
      this.display.requestFocus();
      Settings.set(Settings.DRIVE_FILE + Integer.toString(computer.getCurrentDrive()), "empty");
      Settings.setBoolean(Settings.LOADDRIVE + Integer.toString(computer.getCurrentDrive()), false);
      Display.showdisk = 150;
  }

  public void setComputer(final String name) throws Exception {
      
    turnOn.play();
    Switches.luminance = 0;
    Display.txtpos = Display.txtstart;
    Display.ytext = Display.ztext;
    Switches.loaddrivea = "Drive is empty.";
    Switches.loaddriveb = "Drive is empty.";  
    Switches.loaddrivec = "Drive is empty.";
    Switches.loaddrived = "Drive is empty.";   
    System.out.println(name + " choosen.");
    Settings.set(Settings.SYSTEM, name);
    setComputer(name, true);
    Display.model = "" + computer;
    Display.showmodel = 100;
    compsys = name;
  }

  public void setComputer(final String name, final boolean start) throws Exception {
      Status1.setText(" " + name + " ");
    if (computer == null || !name.equalsIgnoreCase(computer.getName())) {
        compsys = name;
      Computer newComputer = Computer.createComputer(this, name);
      if (computer != null) {
        Drive[] floppies = computer.getFloppyDrives();
        if (floppies != null)
          for (int i = 0; i < floppies.length; i++)
            if (floppies[i] != null)
              floppies[i].setActiveListener(null);
        computer.dispose();
        computer = null;
        Runtime runtime = Runtime.getRuntime();
        runtime.gc();
        runtime.runFinalization();
        runtime.gc();
        System.out.println("Computer Disposed");
      }
      computer = newComputer;
        Settings.set(Settings.SYSTEM, name);
      setFullSize(large);
      computer.initialise();
      Drive[] floppies = computer.getFloppyDrives();
      if (floppies != null)
        for (int i = 0; i < floppies.length; i++)
          if (floppies[i] != null)
            floppies[i].setActiveListener(this);
    //  this.jcbImage.removeAllItems();
      this.jcbDrive.removeAllItems();
      gotGames = false;
      try {
        Vector files = computer.getFiles();
        for (int i = 0; i < files.size(); i++) {
       //   this.jcbImage.addItem(files.elementAt(i));
        }
      //  this.jcbImage.setSelectedIndex(-1);
      } finally {
        gotGames = true;
      }

      final Vector floppydrives = getDrives();
      for (int i = 0; i < floppydrives.size(); i++) {
        this.jcbDrive.addItem(floppydrives.elementAt(i));
      }
      if (Switches.computersys == 0) {
        this.jcbDrive.setSelectedIndex(-1);
      } else {
        this.jcbDrive.setSelectedIndex(0);
      }

      if (debugger != null)
        debugger.setComputer(computer);
      if (start)
        computer.start();
    }
  }
  
  public void setAudio(final boolean value){
      audiooutput = value;
      if (audiooutput)
          Switches.audioenabler = 1;
      else
          Switches.audioenabler = 0;
      this.display.requestFocus();
  }
  
  public void setTurbo(final boolean value){
      boolean turbocheck = value;
      if (turbocheck)
          Switches.turbo = 3;
      else
          Switches.turbo = 1;
      this.display.requestFocus();
  }
  
  public void setFloppy(final boolean value){
      floppyoutput = value;
      if (floppyoutput)
          Switches.floppysound = true;
      else
          Switches.floppysound = false;
      this.display.requestFocus();
  }
  
  public void setJoy(final boolean value){
      altjoystick = value;
      if (altjoystick)
          Switches.notebook = true;
      else
          Switches.notebook = false;
      this.display.requestFocus();
  }

  public void showAutotype(){
      
        Autotype.typeconsole.setVisible(true);
    //  new Autotype();
  }
  
  public void setFullSize(boolean value) {
    large = value;   
    if (large){
        if (skinned){
            Moniup.setVisible(false);
            Monidown.setVisible(false);
            Monileft.setVisible(false);
            Moniright.setVisible(false);
        }
    }else{
        if (skinned){
            Moniup.setVisible(true);
            Monidown.setVisible(true);
            Monileft.setVisible(true);
            Moniright.setVisible(true);
        }        
    }
    boolean running = computer.isRunning();
    computer.stop();
    computer.setLarge(large);
    display.setImageSize(computer.getDisplaySize(large), computer.getDisplayScale(large));
    computer.setDisplay(display);
    if (running)
      computer.start();
    this.display.requestFocus();
  }
  
  public void insertDisk(){
      loadtimer = 1;
  }
  
  public void setDoubleSize(final boolean value){
      Switches.triplesize = false;
      Switches.doublesize = value;
            if (Switches.doublesize){
        if (skinned){
            Moniup.setVisible(false);
            Monidown.setVisible(false);
            Monileft.setVisible(false);
            Moniright.setVisible(false);
        }
      }else{
        if (skinned){
            if (!large){
            Moniup.setVisible(true);
            Monidown.setVisible(true);
            Monileft.setVisible(true);
            Moniright.setVisible(true);
            }
        }        
    }
          fullscreen = false;
              Settings.setBoolean(Settings.TRIPLE, false);
              Settings.setBoolean(Settings.DOUBLE, value);
    final boolean running = computer.isRunning();
    computer.stop();
    computer.setLarge(large);
    this.display.setImageSize(computer.getDisplaySize(large), computer.getDisplayScale(large));
    computer.setDisplay(this.display);
    if (running) {
      computer.start();}
    this.display.requestFocus();
  }
  public void setTripleSize(final boolean value){
      Switches.doublesize = false;
      Switches.triplesize = value;
            if (Switches.triplesize){
        if (skinned){
            Moniup.setVisible(false);
            Monidown.setVisible(false);
            Monileft.setVisible(false);
            Moniright.setVisible(false);
        }
      }else{
        if (skinned){
            if (large != true){
            Moniup.setVisible(true);
            Monidown.setVisible(true);
            Monileft.setVisible(true);
            Moniright.setVisible(true);
            }
        }        
    }
          fullscreen = false;
              Settings.setBoolean(Settings.TRIPLE, value);
              Settings.setBoolean(Settings.DOUBLE, false);
    final boolean running = computer.isRunning();
    computer.stop();
    computer.setLarge(large);
    this.display.setImageSize(computer.getDisplaySize(large), computer.getDisplayScale(large));
    computer.setDisplay(this.display);
    if (running) {
      computer.start();}
    this.display.requestFocus();
  }


  public Window findWindow(Component comp) {
    while (comp != null)
      if (comp instanceof Window)
        return (Window)comp;
      else
        comp = comp.getParent();
    return null;
  }

  public Vector getFiles() {
    Vector files = computer == null ? new Vector() : computer.getFiles();
    Vector result = files.size() == 0 ? files : new Vector(files.size() * 2);
    for (int i = 0; i < files.size(); i++) {
      FileDescriptor file = (FileDescriptor)files.elementAt(i);
      result.addElement(file.description); // Description
      result.addElement(file.filename); // Name
    }
    return result;
  }

  public Vector getComputers() {
    int count = Computer.COMPUTERS.length;
    Vector result = new Vector(count);
    for (int i = 0; i < count; i++) {
      ComputerDescriptor desc = Computer.COMPUTERS[i];
      if (desc.shown) {
        result.addElement(desc.name);
        result.addElement(desc.key);
      }
    }
    return result;
  }

  public Vector getDrives() {
    int floppydrives = computer == null || computer.getFloppyDrives() == null ? 0 :
      computer.getFloppyDrives().length;
    final Vector result = floppydrives == 0 ? new Vector() : new Vector(floppydrives);
    for (int i = 0; i < floppydrives; i++) {
      result.addElement(new String("DF" + i +":"));
    }
    return result;
  }

  public void focusLost(FocusEvent e) {
 // Switches.audioenabler = 0;
    computer.displayLostFocus();
  }

  public void focusGained(FocusEvent e) {
      
    /*    if (audiooutput){
      boolean audioon = Settings.getBoolean(Settings.AUDIO, true);
        if (audioon)
            Switches.audioenabler = 1;}*/
  }

  public void actionPerformed(ActionEvent e) {
      
      if (e.getSource() == ok){
          options.dispose();
          Options=false;
      }
      
        if (e.getSource() == applyroms){
            putRoms();
            
        }
        if (e.getSource() == okroms){
            putRoms();
            romsetter.dispose();
            
        }
        if (e.getSource() == cancelroms){
            romsetter.dispose();
            
        }
        if  (e.getSource() == s64){
              snaChooser.dispose();
              Switches.save64 = true;
          }
        if (e.getSource() == s128){
              snaChooser.dispose();
              Switches.save128 = true;
          }
          if (e.getSource() == s256){
              snaChooser.dispose();
              Switches.save256 = true;
          }
          if (e.getSource() == s512){
              snaChooser.dispose();
              Switches.save512 = true;
          }
          if (e.getSource() == cancel){
              snaChooser.dispose();
          }
      else
         if (e.getSource() instanceof MenuItem)
    {
       String menuAdd = e.getActionCommand();
       if (menuAdd.equals("Quit")){
            Autotype.save();
           System.exit(0);
       }
       else
       if (menuAdd.equals("Reset            Ctrl + F9")) computer.reset();
       else
       if (menuAdd.equals("Reboot")) reBoot();
       else
       if (menuAdd.equals("About")){
        if (executable)
                frame.setAlwaysOnTop(false);
                info();
        if (executable)
                frame.setAlwaysOnTop(onTop);
       }
       else
       if (menuAdd.equals("Create new DSK")){
        if (executable)
                frame.setAlwaysOnTop(false);
                CreateDsk();
        if (executable)
                frame.setAlwaysOnTop(onTop);
       }
       else
       if (menuAdd.equals("Load...")) loaddata();
       else
       if (menuAdd.equals("Debugger")) showDebugger();
       else
       if (menuAdd.equals("Boot CP/M")) computer.bootCPM();
       else
       if (menuAdd.equals("ROM Setup")){
        if (executable)           
                frame.setAlwaysOnTop(false);
                setRoms();
        if (executable)
                frame.setAlwaysOnTop(onTop);
       }
       else
       if (menuAdd.equals("Java console")) Console.frameconsole.setVisible(true);
       else
       if (menuAdd.equals("Pause")) pausecheck();
       else
       if (menuAdd.equals("Eject all")){
           computer.setCurrentDrive(3);
           mediumeject();
           computer.setCurrentDrive(2);
           mediumeject();
           computer.setCurrentDrive(1);
           mediumeject();
           computer.setCurrentDrive(0);
           mediumeject();
       }
       else
       
       if (menuAdd.equals(df0sav)){
           computer.setCurrentDrive(0);
           Switches.dskcheck=true;
       }
       else
       if (menuAdd.equals(df1sav)){
           computer.setCurrentDrive(1);
           Switches.dskcheck=true;
       }
       else
       if (menuAdd.equals(df2sav)){
           computer.setCurrentDrive(2);
           Switches.dskcheck=true;
       }
       else
       if (menuAdd.equals(df3sav)){
           computer.setCurrentDrive(3);
           Switches.dskcheck=true;
       }
       else
       if (menuAdd.equals(df0save)){          
          computer.setCurrentDrive(0);
        if (executable)
                frame.setAlwaysOnTop(false);
                saveDsk();
        if (executable)
                frame.setAlwaysOnTop(onTop);          
          computer.setCurrentDrive(0);
       }   
       else    
       if (menuAdd.equals(df1save)){          
          computer.setCurrentDrive(1);
        if (executable)
                frame.setAlwaysOnTop(false);
                saveDsk();
        if (executable)
                frame.setAlwaysOnTop(onTop);          
          computer.setCurrentDrive(0);
       }    
       else   
       if (menuAdd.equals(df2save)){          
          computer.setCurrentDrive(2);
        if (executable)
                frame.setAlwaysOnTop(false);
                saveDsk();
        if (executable)
                frame.setAlwaysOnTop(onTop);          
          computer.setCurrentDrive(0);
       }    
       else
       if (menuAdd.equals(screenShot))
           screenshottimer=1;
       else
           if (menuAdd.equals(catchSCR))
            Switches.saveScr = true;
       if (menuAdd.equals(df3save)){          
          computer.setCurrentDrive(3);
        if (executable)
                frame.setAlwaysOnTop(false);
                saveDsk();
        if (executable)
                frame.setAlwaysOnTop(onTop);          
          computer.setCurrentDrive(0);
       }
       else
       if (menuAdd.equals("Merge DSK's...")){
        if (executable)
                frame.setAlwaysOnTop(false);
                dskmerge();
        if (executable)
                frame.setAlwaysOnTop(onTop);
       }    
       else   
       if (menuAdd.equals("Autotype")){
        if (executable)
                frame.setAlwaysOnTop(false);
        Autotype.typeconsole.setVisible(true);
                //new Autotype();
        if (executable)
                frame.setAlwaysOnTop(onTop);
       }
       else
           
       if (menuAdd.equals("Paste      F11")){
           Autotype.PasteText();
       }
       else
       if (menuAdd.equals(df0insert)){           
          computer.setCurrentDrive(0);
          loaddata();
          computer.setCurrentDrive(0);
       }
       else
       if (menuAdd.equals(df1insert)){           
          computer.setCurrentDrive(1);
          loaddata();
          computer.setCurrentDrive(0);
       }
       else
       if (menuAdd.equals(df2insert)){           
          computer.setCurrentDrive(2);
          loaddata();
          computer.setCurrentDrive(0);
       }
       else
       if (menuAdd.equals(df3insert)){           
          computer.setCurrentDrive(3);
          loaddata();
          computer.setCurrentDrive(0);
       }
       else
       if (menuAdd.equals(df0eject)){
           computer.setCurrentDrive(0);
           mediumeject();
           computer.setCurrentDrive(0);          
       }
       else
       if (menuAdd.equals(df1eject)){
           computer.setCurrentDrive(1);
           mediumeject();
           computer.setCurrentDrive(0);          
       }
       else
       if (menuAdd.equals(df2eject)){
           computer.setCurrentDrive(2);
           mediumeject();
           computer.setCurrentDrive(0);          
       }
       else
       if (menuAdd.equals(df3eject)){
           computer.setCurrentDrive(3);
           mediumeject();
           computer.setCurrentDrive(0);          
       }
       else
       if (menuAdd.equals(df0create)){
           computer.setCurrentDrive(0);
           CreateDsk();
           computer.setCurrentDrive(0);          
       }
       else
       if (menuAdd.equals(df1create)){
           computer.setCurrentDrive(1);
            CreateDsk();
           computer.setCurrentDrive(0);          
       }
       else
       if (menuAdd.equals(df2create)){
           computer.setCurrentDrive(2);
           CreateDsk();
           computer.setCurrentDrive(0);          
       }
       else
       if (menuAdd.equals(df3create)){
           computer.setCurrentDrive(3);
           CreateDsk();
           computer.setCurrentDrive(0);          
       }
       else
       if (menuAdd.equals(df0boot)){
           computer.bootDisk();
       }
       else
       if (menuAdd.equals(df1boot)){
           computer.bootDiskb();
       }
       else
       if (menuAdd.equals(Aoptions)){
           if (Options == false)
               OptionPanel();
       }
       if (menuAdd.equals(Oprinter)){
           CPCPrinter.MakeVisible();
       }
       else
           if (menuAdd.equals(loadTXT))
            Autotype.loadFile();
       else
       if (menuAdd.equals(Expansioninfo)){
           ExpansionInfo();
       }
       else
           if (menuAdd.equals(HexEdit))
            hexi = new HexEditor();
      else
          if (menuAdd.equals(snapshot))
              chooseSNA();
      else
          if (menuAdd.equals(binary))
              Switches.BINImport = true;
      else
          if (menuAdd.equals(cpcpalette))
              Switches.showPalette = true;
      else
          if (menuAdd.equals(poke))
              Switches.poke = true;
      else
          if (menuAdd.equals(scores))
              Switches.scores = true;
      else
          if (menuAdd.equals(ENkeys)){
              keys = "English keyboard  ";
              localkeys = "EN_EN";
          Keys.setLabel(keys);
          }
          else
          if (menuAdd.equals(DEkeys)){
              keys = "German keyboard  ";
              localkeys = "DE_DE";
          Keys.setLabel(keys);
          }
          else
          if (menuAdd.equals(ESkeys)){
              keys = "Spanish keyboard  ";
              localkeys = "ES_ES";
          Keys.setLabel(keys);
          }
     }
  }
  
    public void itemStateChanged(final ItemEvent e) {
        
      if (e.getSource() == checkTurbo){
          System.out.println("Turbo is set " + checkTurbo.getState());
          setTurbo(checkTurbo.getState());
      } else
      if (e.getSource() == autosavedsk){
          Switches.autosave = autosavedsk.getState();
          Settings.setBoolean(Settings.AUTOSAVE, autosavedsk.getState());
      } else
      if (e.getSource() == aontop){
        if (executable)
          frame.setAlwaysOnTop(aontop.getState());
          Settings.setBoolean(Settings.ONTOP, aontop.getState());
          onTop = aontop.getState();
      } else
      if (e.getSource() == joyemu){
          Settings.setBoolean(Settings.JOYSTICK, joyemu.getState());
          qaop.setEnabled(joyemu.getState());
          if (joyemu.getState())
              Switches.joystick = 1;
          else
              Switches.joystick = 0;
      } else
      if (e.getSource() == qaop){
          Settings.setBoolean(Settings.NOTEBOOK, qaop.getState());
          Switches.notebook = qaop.getState();
      }
      else
      if(e.getSource() == osdisplay){
        osd = osdisplay.getState();
        Switches.osddisplay = osdisplay.getState();
        Settings.setBoolean(Settings.OSD, osdisplay.getState());
      }
      else
      
      if (e.getSource() == cpc464){
          cpc464.setState(true);
          cpc664.setState(false);
          cpc6128.setState(false);
          customcpc.setState(false);
          try {
          setComputer("CPC464", true);
          LoadFiles();
          reset();
          if (executable)
              defaultSize();
        } catch (final Exception ex) {
          ex.printStackTrace();
        }
      }
      else
      if (e.getSource() == cpc664){
          cpc464.setState(false);
          cpc664.setState(true);
          cpc6128.setState(false);
          customcpc.setState(false);
          try {
          setComputer("CPC664", true);
          LoadFiles();
          reset();
          if (executable)
              defaultSize();
        } catch (final Exception ex) {
          ex.printStackTrace();
        }
      }
      else
      if (e.getSource() == cpc6128){
          cpc464.setState(false);
          cpc664.setState(false);
          cpc6128.setState(true);
          customcpc.setState(false);
          try {
          setComputer("CPC6128", true);
          LoadFiles();
          reset();
          if (executable)
              defaultSize();
        } catch (final Exception ex) {
          ex.printStackTrace();
        }
      }
      else
      if (e.getSource() == customcpc){
          cpc464.setState(false);
          cpc664.setState(false);
          cpc6128.setState(false);
          customcpc.setState(true);
          try {
          setComputer("CUSTOM", true);
          LoadFiles();
          reset();
          if (executable)
              defaultSize();
        } catch (final Exception ex) {
          ex.printStackTrace();
        }
      }
      else
      if (e.getSource() == checkColor){
        Switches.monitormode = 0;
        Display.monmessage = "Colour monitor";
        Settings.set(Settings.MONITOR, "COLOUR");
        Display.showmon = 150;
                    checkColor.setState(true);
                    checkGreen.setState(false);
                    checkGrey.setState(false);
                    checkJColor.setState(false);
      }
      else
      if (e.getSource() == checkGreen){
        Switches.monitormode = 2;
        Display.monmessage = "Green monitor";
        Settings.set(Settings.MONITOR, "GREEN");
        Display.showmon = 150;
                    checkColor.setState(false);
                    checkGreen.setState(true);
                    checkGrey.setState(false);
                    checkJColor.setState(false);
      }
      else
      if (e.getSource() == checkGrey){        
        Switches.monitormode = 3;
        Display.monmessage = "Grey monitor";
        Settings.set(Settings.MONITOR, "GRAY");
        Display.showmon = 150;
                    checkColor.setState(false);
                    checkGreen.setState(false);
                    checkGrey.setState(true);
                    checkJColor.setState(false);
      }
      else
      if (e.getSource() == checkJColor){       
        Switches.monitormode = 1; 
        Display.monmessage = "Colour 32 INKs";
        Settings.set(Settings.MONITOR, "JEMU");
        Display.showmon = 150;
                    checkColor.setState(false);
                    checkGreen.setState(false);
                    checkGrey.setState(false);
                    checkJColor.setState(true);
      }
      if (e.getSource() == checkFPS){       
            if (checkFPS.getState() == true)
                Display.showfps = 1;
            else
                Display.showfps = 0;
                
      }
      
      else
      if (e.getSource() == checkAudio){
          if (checkAudio.getState()){
              Switches.audioenabler = 1;
          Settings.setBoolean(Settings.AUDIO,true);
          }
          else {
              Switches.audioenabler = 0;
              Settings.setBoolean(Settings.AUDIO,false);
              }
      }
      
      else
      if (e.getSource() == checkFull){
            togglesize = checkFull.getState();
          FullSize();
      }
      
      else
      if (e.getSource() == checkGate){
          Switches.doublesize = false;
          Switches.triplesize = false;
          Settings.setBoolean(Settings.DOUBLE, false);
          Settings.setBoolean(Settings.TRIPLE, false);
          Size();
      }
      else
      if (e.getSource() == checkScan){
          ScanLines();
      }
      else
      if (e.getSource() == joymouse){
      if (mousejoy){
          Switches.MouseJoy = false;
          Settings.setBoolean(Settings.MOUSEJOY, false);
          mousejoy = false;}
      else{
          Switches.MouseJoy = true;
          Settings.setBoolean(Settings.MOUSEJOY, true);
          mousejoy = true;}
      }
      else
          
       if (e.getSource() == drivesound){
           fsoundcheck();
       }
      else
          
       if (e.getSource() == unprotect){
           Switches.unprotect = unprotect.getState();
       }
       if (e.getSource() == Printer){
           Switches.Printer = Printer.getState();
          Settings.setBoolean(Settings.PRINTER, Printer.getState());
           Switches.digiblaster = false;
            Settings.setBoolean(Settings.DIGIBLASTER, false);
            Digiblaster.setState(false);
       }
       if (e.getSource() == Expansion){
           Switches.Expansion = Expansion.getState();
            Settings.setBoolean(Settings.EXPANSION, Expansion.getState());
           ExpansionRom();
       }
       else
       if (e.getSource() == Digiblaster){
           Switches.digiblaster = Digiblaster.getState();
            Settings.setBoolean(Settings.DIGIBLASTER, Digiblaster.getState());
           Switches.Printer = false;
          Settings.setBoolean(Settings.PRINTER, false);
          Printer.setState(false);
       }
      
      else
      if (e.getSource() == checkDouble){
          Switches.doublesize = checkDouble.getState();
            if (skinned){
            Moniup.setVisible(false);
            Monidown.setVisible(false);
            Monileft.setVisible(false);
            Moniright.setVisible(false);
            }
          if (Switches.doublesize == false) 
                if (skinned){
            Moniup.setVisible(true);
            Monidown.setVisible(true);
            Monileft.setVisible(true);
            Moniright.setVisible(true);
            }  
          checkTriple.setState(false);
          Switches.triplesize = false;
          fullscreen = false;
          Settings.setBoolean(Settings.DOUBLE, Switches.doublesize);
          Settings.setBoolean(Settings.TRIPLE, false);
          defaultSize();
      }
      else
      if (e.getSource() == checkTriple){
          Switches.triplesize = checkTriple.getState();
          if (skinned){
            Moniup.setVisible(false);
            Monidown.setVisible(false);
            Monileft.setVisible(false);
            Moniright.setVisible(false);
            }
          if (Switches.triplesize == false) 
                if (skinned){
            Moniup.setVisible(true);
            Monidown.setVisible(true);
            Monileft.setVisible(true);
            Moniright.setVisible(true);
            }  
          checkDouble.setState(false);
          Switches.doublesize = false;
          fullscreen = false;
          Settings.setBoolean(Settings.TRIPLE, Switches.triplesize);
          Settings.setBoolean(Settings.DOUBLE, false);
          defaultSize();
      }
      else {
     if (hideframe == true)  {   
    if (e.getStateChange() == ItemEvent.SELECTED && this.gotGames) {
      final Object item = ((JComboBox) e.getSource()).getSelectedItem();
     /* if (e.getSource() == this.jcbImage) {
        loadFile(((FileDescriptor) item).filename);
      }else */
      if (e.getSource() == this.jcbDrive) {
        computer.setCurrentDrive(this.jcbDrive.getSelectedIndex());
        final Vector devices = computer.getDevices();
        final int n = devices.size();
        for (int i = 0; i < n; i++) {
          final Object device = devices.get(i);
          if (device instanceof UPD765A) {
            final UPD765A u = (UPD765A) device;
            final int forcedHead = u.getForcedHead(this.jcbDrive.getSelectedIndex());
            this.driveHead.setSelectedIndex(forcedHead);
          }
        }
      } else 
         if (e.getSource() == this.driveHead) {
        final Vector devices = computer.getDevices();
        final int n = devices.size();
        for (int i = 0; i < n; i++) {
          final Object device = devices.get(i);
          if (device instanceof UPD765A) {
            final UPD765A u = (UPD765A) device;
            u.setForcedHead(this.driveHead.getSelectedIndex(), this.jcbDrive.getSelectedIndex());
          }
        }
      } 
      else {
        try {
          setComputer(((ComputerDescriptor)item).key);
          findWindow(this).pack();
          LoadFiles();
        } catch(Exception ex) {
          ex.printStackTrace();
        }
      }
    }
     }
      }
  }
    
   
  public void saveDsk() {
        if (executable)
      frame.setAlwaysOnTop(false);

        FileDialog filedia = new FileDialog((Frame) frame, "Save DSK...", FileDialog.SAVE);
        filedia.setFile("*.dsk");
        filedia.setVisible(true);
        String filename = filedia.getFile();
        if (filename != null) { 
           filename =  filedia.getDirectory() + filedia.getFile();
            String savename=filename;
            if (!savename.toLowerCase().endsWith(".dsk"))
                        savename=savename + ".dsk";
            File savefile = new File(savename);
      // save disc image
      final Vector devices = computer.getDevices();
      final int n = devices.size();
      for (int i = 0; i < n; i++) {
        final Object device = devices.get(i);
        if (device instanceof UPD765A) {
          final UPD765A u = (UPD765A) device;
          Drive d = u.getDrive(computer.getCurrentDrive());
          DiscImage imager = d.getDisc(this.driveHead.getSelectedIndex());
          imager.saveImage(savefile);
          String insertdisk = savename;
          loadFile(Computer.TYPE_UNKNOWN, insertdisk, false);
          System.out.println("loaded " + insertdisk);
        if (executable)
      frame.setAlwaysOnTop(false);
          JOptionPane.showMessageDialog(null, "Sucessfully saved as " + filedia.getFile());

        if (executable)
      frame.setAlwaysOnTop(onTop);
        }
      }
    }
  }  

  public void driveActiveChanged(Drive drive, boolean active) {
    // Put Drive LED change code here
    // NOTE: Must OR the active state from all Drives for the value
    if (!active) {
      Drive[] floppies = computer.getFloppyDrives();
      if (floppies != null)
        for (int i = 0; i < floppies.length; i++)
          if (floppies[i] != null && floppies[i].isActive()) {
            active = true;
            break;
          }
    }
    Display.ledOn = active ? 1 : 0;
  }
  
  public void message() {
        if (executable)
    frame.setAlwaysOnTop(false);
    JOptionPane.showMessageDialog(null, JJemu);
    Settings.setBoolean(Settings.MESSAGE, false);
        if (executable)
    frame.setAlwaysOnTop(onTop);
  }
  
  

  // Standalone 
  public void Size(){
          frame.dispose();
          frame.setUndecorated(false);
 
      computer.stop();
      Switches.stretch = 0;
      System.out.println("Resizing Window...");
     if (large == true){          
                    large = false;
                    setFullSize(large); 
                    Settings.setBoolean(Settings.LARGE, false);
                } else  
                  if (large == false){
                    large = true;
                    setFullSize(large);
                    Settings.setBoolean(Settings.LARGE, true);
                  }

  if (large){
      System.out.println("Double size - Gare Array is double");
        Display.automessage = "Double size - Gare Array is double";
        Display.showauto = 150; 
  }
  else{
          
      System.out.println("Simple size - Gare Array is half");
        Display.automessage = "Simple size - Gare Array is half";
        Display.showauto = 150; 
  }
            frame.pack();
            final Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
            frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
            winx1 = frame.getSize().width;
            winy1 = frame.getSize().height;

            System.out.println("Window is "+ winx1 + " Pixels with & " + winy1 + " Pixels height!");
        computer.start();
      //Switches.stretch = 1;
      System.out.println("You can stretch the window now.");
            togglesize = true;
            stretcher = false;
            defaultSize();
            frame.setVisible(true);
            this.display.requestFocus();
     }
  
  public void hideFrame(){
     // frame.dispose();
     this.display.setBorder(null);
     frame.pack();
     frame.setVisible(true);
     display.requestFocus();
  }
  public void showFrame(){
     // frame.dispose();
     this.display.setBorder(new BevelBorder(BevelBorder.LOWERED));
     frame.pack();
     frame.setVisible(true);
     display.requestFocus();
  }
  
  public void Turbocheck(){
        if (Switches.turbo == 1){
            Switches.turbo = 3;
        Display.automessage = "JavaCPC is running at 300% CPU-Speed!";
        Display.showauto = 150; }
        else{
            Switches.turbo = 1;
        Display.automessage = "JavaCPC is running at 100% CPU-Speed.";
        Display.showauto = 150;}
    }
  
  public void FullSize(){
      Switches.stretch = 1;
      computer.stop();
      if (togglesize){
            
        if (skinned){
            Moniup.setVisible(false);
            Monidown.setVisible(false);
            Monileft.setVisible(false);
            Moniright.setVisible(false);
        }
          frame.dispose();
          frame.setUndecorated(true);
            final Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
            frame.setSize(d);            
            frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
            togglesize = false;
            Switches.doublesize = false;
            Switches.triplesize = false;
            fullscreen = true;
            Settings.setBoolean(Settings.FULLSCREEN, true);
      }
      else {
            if (skinned){
            if (!large){
            Moniup.setVisible(true);
            Monidown.setVisible(true);
            Monileft.setVisible(true);
            Moniright.setVisible(true);
            }
        }  
          frame.dispose();
          frame.setUndecorated(false);
          final Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
          frame.setSize(winx1,winy1);
          frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
          togglesize = true;
            Switches.doublesize = false;
            Switches.triplesize = false;
            fullscreen = false;
          Settings.setBoolean(Settings.FULLSCREEN, false);
      }
            frame.setVisible(true);
            computer.start();
            this.display.requestFocus();
  }

  
  public void defaultSize(){
      if (stretcher)
          Switches.stretch = 0;
      stretcher = true;
      computer.stop();
          frame.dispose();
          frame.setUndecorated(false);
          final Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
          frame.setSize(winx1,winy1);
          togglesize = true;
          Settings.setBoolean(Settings.FULLSCREEN, false);
          frame.pack();
            frame.setVisible(true);
        
      computer.start();
            this.display.requestFocus();
            Switches.stretch = 1;
            frame.dispose();
          frame.pack();
            frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
            frame.setVisible(true);
  }
  

  
  
    //
    // Settings for romsetter
    //
    
    Frame romsetter = new Frame();  
    String[] ROMs = {
      "none", "AMSDOS.zip", "ART0.zip", "ART1.zip", "ART2.zip",
      "BASIC1-0.zip", "BASIC1-1.zip", "BASIC664.zip",
      "PARADOS.zip", "MAXAM.zip", "sym-romA.zip", "sym-romB.zip",
      "sym-romC.zip", "sym-romD.zip", "T-OG-E-A.zip", "T-OG-E-B.zip",
      "T-OG-E-C.zip", "T-OG-E-D.zip", "ROMPKP1.zip", "ROMPKP2.zip",
      "STK1.zip", "STK2.zip", "locksmit.zip", "KCCBAS.zip", "-BASIC1-1.zip"
    };
  
    String[] OSROMs = {
      "none", "OS464.zip", "OS664.zip", "OS6128.zip", "KCCOS.zip", "-OS.zip",
      "jemuOS6128.zip"
    };
  
  JLabel lorom = new JLabel("Lower Rom");
  JLabel uprom0 = new JLabel("Upper 00");
  JLabel uprom1 = new JLabel("Upper 01");
  JLabel uprom2 = new JLabel("Upper 02");
  JLabel uprom3 = new JLabel("Upper 03");
  JLabel uprom4 = new JLabel("Upper 04");
  JLabel uprom5 = new JLabel("Upper 05");
  JLabel uprom6 = new JLabel("Upper 06");
  JLabel uprom7 = new JLabel("Upper 07");
  JLabel uprom8 = new JLabel("Upper 08");
  JLabel uprom9 = new JLabel("Upper 09");
  JLabel uproma = new JLabel("Upper 10");
  JLabel upromb = new JLabel("Upper 11");
  JLabel upromc = new JLabel("Upper 12");
  JLabel upromd = new JLabel("Upper 13");
  JLabel uprome = new JLabel("Upper 14");
  JLabel upromf = new JLabel("Upper 15");
  JLabel romblank = new JLabel("          ");
  JComboBox LOWER = new JComboBox(OSROMs);
  JComboBox UPPER_0 = new JComboBox(ROMs);
  JComboBox UPPER_1 = new JComboBox(ROMs);
  JComboBox UPPER_2 = new JComboBox(ROMs);
  JComboBox UPPER_3 = new JComboBox(ROMs);
  JComboBox UPPER_4 = new JComboBox(ROMs);
  JComboBox UPPER_5 = new JComboBox(ROMs);
  JComboBox UPPER_6 = new JComboBox(ROMs);
  JComboBox UPPER_7 = new JComboBox(ROMs);
  JComboBox UPPER_8 = new JComboBox(ROMs);
  JComboBox UPPER_9 = new JComboBox(ROMs);
  JComboBox UPPER_A = new JComboBox(ROMs);
  JComboBox UPPER_B = new JComboBox(ROMs);
  JComboBox UPPER_C = new JComboBox(ROMs);
  JComboBox UPPER_D = new JComboBox(ROMs);
  JComboBox UPPER_E = new JComboBox(ROMs);
  JComboBox UPPER_F = new JComboBox(ROMs);
  
  JButton applyroms = new JButton("Apply");
  JButton cancelroms = new JButton("Cancel");
  JButton okroms = new JButton("Ok");
  
  
  public void StoreRoms(){
      
        Settings.set(Settings.UPPER_F, Switches.UPPER_F);
        Settings.set(Settings.UPPER_E, Switches.UPPER_E);
        Settings.set(Settings.UPPER_D, Switches.UPPER_D);
        Settings.set(Settings.UPPER_C, Switches.UPPER_C);
        Settings.set(Settings.UPPER_B, Switches.UPPER_B);
        Settings.set(Settings.UPPER_A, Switches.UPPER_A);
        Settings.set(Settings.UPPER_9, Switches.UPPER_9);
        Settings.set(Settings.UPPER_8, Switches.UPPER_8);
        Settings.set(Settings.UPPER_7, Switches.UPPER_7);
        Settings.set(Settings.UPPER_6, Switches.UPPER_6);
        Settings.set(Settings.UPPER_5, Switches.UPPER_5);
        Settings.set(Settings.UPPER_4, Switches.UPPER_4);
        Settings.set(Settings.UPPER_3, Switches.UPPER_3);
        Settings.set(Settings.UPPER_2, Switches.UPPER_2);
        Settings.set(Settings.UPPER_1, Switches.UPPER_1);
        Settings.set(Settings.UPPER_0, Switches.UPPER_0);
        Settings.set(Settings.LOWER, Switches.LOWER);
        
        }
  
  public void setRoms(){
        
  Switches.romL = Settings.get(Settings.romL, "1");
  Switches.rom0 = Settings.get(Settings.rom0, "5");
  Switches.rom1 = Settings.get(Settings.rom1, "0");
  Switches.rom2 = Settings.get(Settings.rom2, "0");
  Switches.rom3 = Settings.get(Settings.rom3, "0");
  Switches.rom4 = Settings.get(Settings.rom4, "0");
  Switches.rom5 = Settings.get(Settings.rom5, "0");
  Switches.rom6 = Settings.get(Settings.rom6, "0");
  Switches.rom7 = Settings.get(Settings.rom7, "0");
  Switches.rom8 = Settings.get(Settings.rom8, "0");
  Switches.rom9 = Settings.get(Settings.rom9, "0");
  Switches.rom10 = Settings.get(Settings.rom10, "0");
  Switches.rom11 = Settings.get(Settings.rom11, "0");
  Switches.rom12 = Settings.get(Settings.rom12, "0");
  Switches.rom13 = Settings.get(Settings.rom13, "0");
  Switches.rom14 = Settings.get(Settings.rom14, "0");
  Switches.rom15 = Settings.get(Settings.rom15, "0");
 
  LOWER.setSelectedIndex(Integer.parseInt(Switches.romL));
  UPPER_0.setSelectedIndex(Integer.parseInt(Switches.rom0));
  UPPER_1.setSelectedIndex(Integer.parseInt(Switches.rom1));
  UPPER_2.setSelectedIndex(Integer.parseInt(Switches.rom2));
  UPPER_3.setSelectedIndex(Integer.parseInt(Switches.rom3));
  UPPER_4.setSelectedIndex(Integer.parseInt(Switches.rom4));
  UPPER_5.setSelectedIndex(Integer.parseInt(Switches.rom5));
  UPPER_6.setSelectedIndex(Integer.parseInt(Switches.rom6));
  UPPER_7.setSelectedIndex(Integer.parseInt(Switches.rom7));
  UPPER_8.setSelectedIndex(Integer.parseInt(Switches.rom8));
  UPPER_9.setSelectedIndex(Integer.parseInt(Switches.rom9));
  UPPER_A.setSelectedIndex(Integer.parseInt(Switches.rom10));
  UPPER_B.setSelectedIndex(Integer.parseInt(Switches.rom11));
  UPPER_C.setSelectedIndex(Integer.parseInt(Switches.rom12));
  UPPER_D.setSelectedIndex(Integer.parseInt(Switches.rom13));
  UPPER_E.setSelectedIndex(Integer.parseInt(Switches.rom14));
  UPPER_F.setSelectedIndex(Integer.parseInt(Switches.rom15));
    applyroms.addActionListener(this);
    cancelroms.addActionListener(this);
    okroms.addActionListener(this);
      romsetter.setLayout(new GridBagLayout());
      romsetter.add(lorom,getGridBagConstraints(1, 1, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(LOWER,getGridBagConstraints(1, 2, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(uprom0,getGridBagConstraints(1, 3, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_0,getGridBagConstraints(1, 4, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(uprom1,getGridBagConstraints(1, 5, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_1,getGridBagConstraints(1, 6, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(uprom2,getGridBagConstraints(1, 7, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_2,getGridBagConstraints(1, 8, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(uprom3,getGridBagConstraints(1, 9, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_3,getGridBagConstraints(1, 10, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(uprom4,getGridBagConstraints(1, 11, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_4,getGridBagConstraints(1, 12, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(uprom5,getGridBagConstraints(1, 13, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_5,getGridBagConstraints(1, 14, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(uprom6,getGridBagConstraints(1, 15, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_6,getGridBagConstraints(1, 16, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(uprom7,getGridBagConstraints(1, 17, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_7,getGridBagConstraints(1, 18, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(romblank,getGridBagConstraints(1, 19, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(uprom8,getGridBagConstraints(3, 3, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_8,getGridBagConstraints(3, 4, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(uprom9,getGridBagConstraints(3, 5, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_9,getGridBagConstraints(3, 6, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(uproma,getGridBagConstraints(3, 7, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_A,getGridBagConstraints(3, 8, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(upromb,getGridBagConstraints(3, 9, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_B,getGridBagConstraints(3, 10, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(upromc,getGridBagConstraints(3, 11, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_C,getGridBagConstraints(3, 12, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(upromd,getGridBagConstraints(3, 13, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_D,getGridBagConstraints(3, 14, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(uprome,getGridBagConstraints(3, 15, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_E,getGridBagConstraints(3, 16, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(upromf,getGridBagConstraints(3, 17, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(UPPER_F,getGridBagConstraints(3, 18, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      
      romsetter.add(okroms,getGridBagConstraints(1, 20, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(applyroms,getGridBagConstraints(2, 20, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      romsetter.add(cancelroms,getGridBagConstraints(3, 20, 0.0, 0.0, 1, GridBagConstraints.BOTH));

       
                romsetter.setTitle("JavaCPC ROM settings");
                 
                romsetter.setAlwaysOnTop(true);

                romsetter.pack();
                romsetter.setVisible(true);
  }
  
  public void putRoms(){
                    Switches.LOWER = LOWER.getSelectedItem().toString();
                    Switches.UPPER_0 = UPPER_0.getSelectedItem().toString();
                    Switches.UPPER_1 = UPPER_1.getSelectedItem().toString();
                    Switches.UPPER_2 = UPPER_2.getSelectedItem().toString();
                    Switches.UPPER_3 = UPPER_3.getSelectedItem().toString();
                    Switches.UPPER_4 = UPPER_4.getSelectedItem().toString();
                    Switches.UPPER_5 = UPPER_5.getSelectedItem().toString();
                    Switches.UPPER_6 = UPPER_6.getSelectedItem().toString();
                    Switches.UPPER_7 = UPPER_7.getSelectedItem().toString();
                    Switches.UPPER_8 = UPPER_8.getSelectedItem().toString();
                    Switches.UPPER_9 = UPPER_9.getSelectedItem().toString();
                    Switches.UPPER_A = UPPER_A.getSelectedItem().toString();
                    Switches.UPPER_B = UPPER_B.getSelectedItem().toString();
                    Switches.UPPER_C = UPPER_C.getSelectedItem().toString();
                    Switches.UPPER_D = UPPER_D.getSelectedItem().toString();
                    Switches.UPPER_E = UPPER_E.getSelectedItem().toString();
                    Switches.UPPER_F = UPPER_F.getSelectedItem().toString();
                    Switches.romL = Integer.toString(LOWER.getSelectedIndex());
                    Switches.rom0 = Integer.toString(UPPER_0.getSelectedIndex());
                    Switches.rom1 = Integer.toString(UPPER_1.getSelectedIndex());
                    Switches.rom2 = Integer.toString(UPPER_2.getSelectedIndex());
                    Switches.rom3 = Integer.toString(UPPER_3.getSelectedIndex());
                    Switches.rom4 = Integer.toString(UPPER_4.getSelectedIndex());
                    Switches.rom5 = Integer.toString(UPPER_5.getSelectedIndex());
                    Switches.rom6 = Integer.toString(UPPER_6.getSelectedIndex());
                    Switches.rom7 = Integer.toString(UPPER_7.getSelectedIndex());
                    Switches.rom8 = Integer.toString(UPPER_8.getSelectedIndex());
                    Switches.rom9 = Integer.toString(UPPER_9.getSelectedIndex());
                    Switches.rom10 = Integer.toString(UPPER_A.getSelectedIndex());
                    Switches.rom11 = Integer.toString(UPPER_B.getSelectedIndex());
                    Switches.rom12 = Integer.toString(UPPER_C.getSelectedIndex());
                    Switches.rom13 = Integer.toString(UPPER_D.getSelectedIndex());
                    Switches.rom14 = Integer.toString(UPPER_E.getSelectedIndex());
                    Switches.rom15 = Integer.toString(UPPER_F.getSelectedIndex());

                    Settings.set(Settings.romL, Switches.romL);
                    Settings.set(Settings.rom0, Switches.rom0);
                    Settings.set(Settings.rom1, Switches.rom1);
                    Settings.set(Settings.rom2, Switches.rom2);
                    Settings.set(Settings.rom3, Switches.rom3);
                    Settings.set(Settings.rom4, Switches.rom4);
                    Settings.set(Settings.rom5, Switches.rom5);
                    Settings.set(Settings.rom6, Switches.rom6);
                    Settings.set(Settings.rom7, Switches.rom7);
                    Settings.set(Settings.rom8, Switches.rom8);
                    Settings.set(Settings.rom9, Switches.rom9);
                    Settings.set(Settings.rom10, Switches.rom10);
                    Settings.set(Settings.rom11, Switches.rom11);
                    Settings.set(Settings.rom12, Switches.rom12);
                    Settings.set(Settings.rom13, Switches.rom13);
                    Settings.set(Settings.rom14, Switches.rom14);
                    Settings.set(Settings.rom15, Switches.rom15);
                    
                StoreRoms();

         try {
          setComputer("RAMSETTER", false);
          
          if (executable)
              defaultSize();
          setComputer("CUSTOM", true);
          if (executable)
              defaultSize();
          findWindow(this).pack();
          LoadFiles();
        } catch (final Exception ex) {
          ex.printStackTrace();
        }
  } 
  
  
  //
  // Settings for new menu
  //
  
 Frame onlinemenu = new Frame(){
     
     protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
         onlinemenu.dispose();
        }
      }

      public synchronized void setTitle(String title) {
        super.setTitle(title);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      }
     
 };
 

 protected boolean showmenu;
 protected boolean showonlinemenu;
      public   MenuBar JavaCPCMenu = new MenuBar();
     Menu menue1 = new Menu("File");
     Menu menue2 = new Menu("Emulation");
     Menu menue3 = new Menu("Settings");
     Menu menue4 = new Menu("Monitor");
     Menu menue5 = new Menu("Help");
     Menu menue6 = new Menu("Edit");
     public static Menu menue7 = new Menu("  Floppystatus");
     
     Menu drives = new Menu("Drives");
     Menu df0 = new Menu("DF0:");
     Menu df1 = new Menu("DF1:");
     Menu df2 = new Menu("DF2:");
     Menu df3 = new Menu("DF3:");
     Menu systemmenu = new Menu("CPC models");
     Menu joymenu = new Menu ("Joystick");
     Menu keyboard = new Menu ("Keyboard");
     
     String ENkeys = "Force English keyboard";
     String DEkeys = "Force German keyboard";
     String ESkeys = "Force Spanish keyboard";
     Menu Keys = new Menu(keys);
     
     String df0insert = "Insert";
     String df1insert = "Insert ";
     String df2insert = "Insert  ";
     String df3insert = "Insert    ";
     String df0sav      = "Save";
     String df1sav      = "Save ";
     String df2sav      = "Save  ";
     String df3sav      = "Save   ";
     String df0eject =  "Eject";
     String df1eject =  "Eject ";
     String df2eject =  "Eject  ";
     String df3eject =  "Eject   ";
     String df0create = "Create DSK";
     String df1create = "Create DSK ";
     String df2create = "Create DSK  ";
     String df3create = "Create DSK   ";
     String df0boot = "Try to boot";
     String df1boot = "Try to boot ";
     String df0save = "Save DSK as...";
     String df1save = "Save DSK as... ";
     String df2save = "Save DSK as...  ";
     String df3save = "Save DSK as...   ";
     String screenShot="Save Screenshot     Ctrl + F11";
     String catchSCR="Catch CPC Screen (16k)";
     String Aoptions="Advanced options     Ctrl + F10";
     String Oprinter="Open printer console";
     String loadTXT = "Import ASCII file";
     String HexEdit = "Open Hex Editor";
     String snapshot = "Save snapshot file";
     String binary = "Import CPC file";
     String poke = "Poke Memory";
     String scores = "Get Scores";
     String cpcpalette = "Show actual palette";
     CheckboxMenuItem checkTurbo =  new CheckboxMenuItem("Turbo");
     CheckboxMenuItem checkColor =  new CheckboxMenuItem("Color");
     CheckboxMenuItem checkGrey =   new CheckboxMenuItem("Grey");
     CheckboxMenuItem checkGreen =  new CheckboxMenuItem("Green");
     CheckboxMenuItem checkFPS =    new CheckboxMenuItem("Show FPS");
     CheckboxMenuItem checkJColor = new CheckboxMenuItem("JEMU 32 Inks");
     CheckboxMenuItem checkAudio =  new CheckboxMenuItem("Audio");
     CheckboxMenuItem checkFull =   new CheckboxMenuItem("Fullscreen");
     CheckboxMenuItem checkDouble = new CheckboxMenuItem("Double size");
     CheckboxMenuItem checkTriple = new CheckboxMenuItem("Triple size");
     CheckboxMenuItem checkGate =   new CheckboxMenuItem("Full Gatearray");
     CheckboxMenuItem checkScan =   new CheckboxMenuItem("Scanlines");
     CheckboxMenuItem cpc464 =      new CheckboxMenuItem("CPC 464");
     CheckboxMenuItem cpc664 =      new CheckboxMenuItem("CPC 664");
     CheckboxMenuItem cpc6128 =     new CheckboxMenuItem("CPC 6128");
     CheckboxMenuItem customcpc =   new CheckboxMenuItem("Custom CPC");
     CheckboxMenuItem osdisplay =   new CheckboxMenuItem("OSD");
     CheckboxMenuItem autosavedsk = new CheckboxMenuItem("Autosave");
     CheckboxMenuItem joyemu =      new CheckboxMenuItem("Joystick");
     CheckboxMenuItem qaop =        new CheckboxMenuItem("Alternative control");
     CheckboxMenuItem joymouse =    new CheckboxMenuItem("Mousejoystick");
     CheckboxMenuItem aontop =      new CheckboxMenuItem("Always on top");
     CheckboxMenuItem drivesound =  new CheckboxMenuItem("Drive sound");
     CheckboxMenuItem unprotect =   new CheckboxMenuItem("Force no write protection");
     CheckboxMenuItem Printer=      new CheckboxMenuItem("Enable Printer");
     CheckboxMenuItem Expansion=    new CheckboxMenuItem("JavaCPC Expansion ROM");
     CheckboxMenuItem Digiblaster=  new CheckboxMenuItem("DigiBlaster output");
     String Expansioninfo = "Expansion Info";
 public void SetMenu() {
     menue1.add("Load...");
     menue1.add("Boot CP/M");
     menue1.add(drives);
        drives.add(df0);
        df0.add(df0insert);
        df0.add(df0boot);
        df0.add(df0eject);
        df0.addSeparator();
        df0.add(df0create);
        df0.add(df0sav);
        df0.add(df0save);
        drives.add(df1);
        df1.add(df1insert);
        df1.add(df1boot);
        df1.add(df1eject);
        df1.addSeparator();
        df1.add(df1create);
        df1.add(df1sav);
        df1.add(df1save);
        drives.addSeparator();
        drives.add(df2);
        df2.add(df2insert);
        df2.add(df2eject);
        df2.addSeparator();
        df2.add(df2create);
        df2.add(df2sav);
        df2.add(df2save);
        drives.add(df3);
        df3.add(df3insert);
        df3.add(df3eject);
        df3.addSeparator();
        df3.add(df3create);
        df3.add(df3sav);
        df3.add(df3save);
        drives.addSeparator();
        drives.add("Eject all");
        drives.addSeparator();
        drives.add(unprotect);
        drives.addSeparator();
        drives.add(drivesound);
     menue1.addSeparator();
     menue1.add(autosavedsk);
     menue1.add("Merge DSK's...");
     
     menue1.addSeparator();
     menue1.add(loadTXT);
     menue1.add(binary);
     menue1.addSeparator();
     menue1.add(snapshot);
     menue1.addSeparator();
     menue1.add("Quit");
     menue2.add("Pause");
     menue2.add("Reset            Ctrl + F9");
     menue2.add("Reboot");
     menue2.addSeparator();
     menue2.add(systemmenu);
        systemmenu.add(cpc464);
        systemmenu.add(cpc664);
        systemmenu.add(cpc6128);
        systemmenu.addSeparator();
        systemmenu.add(customcpc);
        systemmenu.addSeparator();
        systemmenu.add("ROM Setup");
     
     
     menue2.addSeparator();
     menue2.add(checkTurbo);
     menue3.add(checkAudio);
     menue3.addSeparator();
     menue3.add(joymenu);
        joymenu.add(joyemu);
        joymenu.add(qaop);
        joymenu.addSeparator();
        joymenu.add(joymouse);
     menue2.addSeparator();
     menue2.add(Expansion);
     menue2.add(Expansioninfo);
     menue3.addSeparator();
     menue3.add(keyboard);
        keyboard.add(Keys);
        Keys.add(ENkeys);
        Keys.add(DEkeys);
        Keys.add(ESkeys);
     menue3.addSeparator();
     menue3.add(Printer);
     menue3.add(Digiblaster);
     menue3.addSeparator();
     menue3.add(aontop);
     menue3.addSeparator();
     menue3.add(Aoptions);
     menue4.add(checkColor);
     menue4.add(checkGreen);
     menue4.add(checkGrey);
     menue4.add(checkJColor);
     menue4.addSeparator();
     menue4.add(checkFull);
     menue4.add(checkDouble);
     menue4.add(checkTriple);
     menue4.add(checkGate);
     menue4.addSeparator();
     menue4.add(checkScan);
     menue4.addSeparator();
     menue4.add(osdisplay);
     menue4.add(checkFPS);
     menue5.addSeparator();
     menue5.add("Debugger");
     menue5.add("Java console");
     menue5.addSeparator();
     menue5.add("About");
     
     
     
     menue6.add("Autotype");
     menue6.add("Paste      F11");
     menue6.addSeparator();
     menue6.add(poke);
     menue6.add(scores);
     menue6.addSeparator();
     menue6.add(catchSCR);
     menue6.add(screenShot);
     menue6.addSeparator();
     menue6.add(Oprinter);
     menue6.add(HexEdit);
     menue6.addSeparator();
     menue6.add(cpcpalette);
     
     JavaCPCMenu.add(menue1);
     JavaCPCMenu.add(menue6);
     JavaCPCMenu.add(menue2);
     JavaCPCMenu.add(menue3);
     JavaCPCMenu.add(menue4);
     JavaCPCMenu.add(menue5);
     JavaCPCMenu.add(menue7);
    
     menue1.addActionListener(this);
     menue2.addActionListener(this);
     menue3.addActionListener(this);
     menue4.addActionListener(this);
     menue5.addActionListener(this);
     menue6.addActionListener(this);
     menue7.setFont(new Font("Arial",0,9));
     systemmenu.addActionListener(this);
     df0.addActionListener(this);
     df1.addActionListener(this);
     df2.addActionListener(this);
     df3.addActionListener(this);
     joymenu.addActionListener(this);
     drives.addActionListener(this);
     keyboard.addActionListener(this);
     Keys.addActionListener(this);
     
     checkTurbo.addItemListener(this);
     checkColor.addItemListener(this);
     checkGreen.addItemListener(this);
     checkGrey.addItemListener(this);
     checkJColor.addItemListener(this);
     checkFPS.addItemListener(this);
     checkAudio.addItemListener(this);
     checkFull.addItemListener(this);
     checkDouble.addItemListener(this);
     checkTriple.addItemListener(this);
     checkGate.addItemListener(this);
     checkScan.addItemListener(this);
     cpc464.addItemListener(this);
     cpc664.addItemListener(this);
     cpc6128.addItemListener(this);
     customcpc.addItemListener(this);
     autosavedsk.addItemListener(this);
     osdisplay.addItemListener(this);
     joyemu.addItemListener(this);
     qaop.addItemListener(this);
     joymouse.addItemListener(this);
     aontop.addItemListener(this);
     drivesound.addItemListener(this);
     unprotect.addItemListener(this);
     Printer.addItemListener(this);
     Expansion.addItemListener(this);
     Digiblaster.addItemListener(this);
     
  }   
 public void OnlineMenu(){    
     final Dimension d = Toolkit.getDefaultToolkit().getScreenSize();

      onlinemenu.setMenuBar(JavaCPCMenu);
      onlinemenu.setTitle("JavaCPC - OnlineApplet menu");
      
      onlinemenu.add(JLogo);
      onlinemenu.pack();
      onlinemenu.setLocation((d.width - onlinemenu.getSize().width), (0));
      onlinemenu.setAlwaysOnTop(true);
      onlinemenu.setVisible(true);
  }
 public void mouseMoved(MouseEvent me)
     {  
     xoldpos = xpos;
     yoldpos = ypos;
     xpos = me.getX();
     ypos = me.getY();
     if (mousejoy){
           
            if (xoldpos <= xpos - 1){
            Switches.directR = 0;
            Switches.directxR = "Right";
            Switches.directxL = "Stop";
            }
            else
            if (xoldpos >= xpos + 1){
            Switches.directL = 0;
            Switches.directxR = "Stop";
            Switches.directxL = "Left";
            }
            
            if (yoldpos >= ypos + 1){
            Switches.directU = 0;
            Switches.directyU = "Up";
            Switches.directyD = "Stop";
            }
            else
            if (yoldpos <= ypos - 1){
            Switches.directD = 0;
            Switches.directyU = "Stop";
            Switches.directyD = "Down";
            }
     }
     } 
   public void mouseDragged(MouseEvent me)  
     {  
     xoldpos = xpos;
     yoldpos = ypos;
     xpos = me.getX();
     ypos = me.getY();
     if (mousejoy){
            if (xoldpos <= xpos - 1){
            Switches.directR = 0;
            Switches.directxR = "Right";
            Switches.directxL = "Stop";
            }
            else
            if (xoldpos >= xpos + 1){
            Switches.directL = 0;
            Switches.directxR = "Stop";
            Switches.directxL = "Left";
            }
            
            if (yoldpos >= ypos + 1){
            Switches.directU = 0;
            Switches.directyU = "Up";
            Switches.directyD = "Stop";
            }
            else
            if (yoldpos <= ypos - 1){
            Switches.directD = 0;
            Switches.directyU = "Stop";
            Switches.directyD = "Down";
            }
                
        if ((me.getModifiers() & MouseEvent.BUTTON1_MASK) != 0)
           computer.MouseFire1();
           else
           computer.MouseFire2();
        }
     }  
   protected void ScanLines(){
       if (checkScan.getState()){
           Switches.ScanLines = true;
       Settings.setBoolean(Settings.SCANLINES, true);
       }
       else {
           Switches.ScanLines = false;
       Settings.setBoolean(Settings.SCANLINES, false);
       }
   }
 protected void fsoundInit(){
           if (fsound) {
        Switches.floppysound = true;
        System.out.println("Floppysound Enabled");
      } else {
        Switches.floppysound = false;
        System.out.println("Audio Disabled");
      }
 }
 
  public void screenshot(){
      if (executable)
        frame.setAlwaysOnTop(false); 
      computer.stop();
      display.grabFocus();
       display.requestFocus();
       
       try  
 {    
       Rectangle rect = new Rectangle(display.getBounds());
       rect.setLocation(display.getLocationOnScreen());
           if (fullscreen){
            final Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
            images = new BufferedImage(d.width, d.height,  BufferedImage.SCALE_SMOOTH);
            images.getGraphics().drawImage(Switches.image, 0,0, d.width, d.height, null);
           } else
           if (Switches.doublesize){
            images = new BufferedImage(Switches.image.getWidth() * 2, Switches.image.getHeight() * 2,  BufferedImage.SCALE_SMOOTH);
            images.getGraphics().drawImage(Switches.image, 0,0, Switches.image.getWidth() * 2, Switches.image.getHeight() * 2, null);
           } else
           if (Switches.triplesize){
            images = new BufferedImage(Switches.image.getWidth() * 3, Switches.image.getHeight() * 3,  BufferedImage.SCALE_SMOOTH);
            images.getGraphics().drawImage(Switches.image, 0,0, Switches.image.getWidth() * 3, Switches.image.getHeight() * 3, null);
           } else
            if (large){
            images = new BufferedImage(Switches.image.getWidth(), Switches.image.getHeight() * 2,  BufferedImage.SCALE_SMOOTH);
            images.getGraphics().drawImage(Switches.image, 0,0, Switches.image.getWidth(), Switches.image.getHeight() * 2, null);
            } else
            images = Switches.image;
       
       File file;  
       screenPreview();
              FileDialog filedia = new FileDialog((Frame) frame, "Save Screenshot (Please add PNG,BMP,GIF or JPG extension)", FileDialog.SAVE);
        filedia.setFile("*.bmp; *.png; *.jpg; *.gif");
        filedia.setVisible(true);
        String filename = filedia.getFile();
        if (filename != null) { 
           filename =  filedia.getDirectory() + filedia.getFile();
            String savename=filename;
       if (savename.toLowerCase().endsWith(".png")){
       file = new File(savename); 
       ImageIO.write(images, "png", file);
       } else
       if (savename.toLowerCase().endsWith(".gif")){
       file = new File(savename); 
       ImageIO.write(images, "gif", file);
       } else 
       if (savename.toLowerCase().endsWith(".bmp")){
       file = new File(savename); 
       ImageIO.write(images, "bmp", file);
       } else
       if (savename.toLowerCase().endsWith(".jpg")){
       file = new File(savename); 
       ImageIO.write(images, "jpg", file);
       } else {
       savename=savename+".bmp";
       file = new File(savename); 
       ImageIO.write(images, "bmp", file);
       }
    }
        screenpreview.dispose();
 }  
 catch (Exception e)  
 {  
       System.out.println(e.getMessage());  
 }
       screenshottimer = 0;
       computer.start();
      if (executable)
        frame.setAlwaysOnTop(onTop); 
  }
  

  protected void screenPreview(){
      screenpreview = new JFrame(){
     
     protected void processWindowEvent(WindowEvent e) {
        super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
         screenpreview.dispose();
        }
      }

      public synchronized void setTitle(String title) {
        super.setTitle(title);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      }
     
 };
      screenpreview.setTitle("Screenshot");
           ImageIcon spr = null;
            spr = new ImageIcon(images);
            sprev = new JLabel(spr);
      screenpreview.add(sprev);
      screenpreview.pack();
      screenpreview.setLocation(0, 0);
      screenpreview.setVisible(true);
  }
      public void UpdateCheck() throws Exception{
          if (!checkVer) return;
        URL url = new URL("http://cpc-live.com/update.txt");
        update="";
        URLConnection uc = url.openConnection();
        InputStreamReader input = new InputStreamReader(uc.getInputStream());
		BufferedReader in = new BufferedReader(input);
		String inputLine;

		while ((inputLine = in.readLine()) != null) {
			update = update + inputLine;
		}

        System.out.println("Your version is: " + version);
        System.out.println("Latest version on server is " + update);
        if (version.equals(update))
            System.out.println("Your are using the latest version of JavaCPC.");
        else {
            System.out.println("Please update your copy of JavaCPC...");
        JOptionPane.showMessageDialog(null, "Dear JavaCPC-user,\n" +
                "you are using version "+ version +" of JavaCPC.\n" +
                "Please visit http://cpc-live.com\n" +
                "and download JavaCPC version "+ update+".");
        try {
            ShowInfo();
        }
         catch (Exception e)  
        {  
            System.out.println(e.getMessage());  
        }
        }
    }
      
      public void ShowInfo() throws Exception{
        URL url = new URL("http://cpc-live.com/updateinfo.txt");
        update ="";
        URLConnection uc = url.openConnection();
        InputStreamReader input = new InputStreamReader(uc.getInputStream());
		BufferedReader in = new BufferedReader(input);
		String inputLine;

		while ((inputLine = in.readLine()) != null) {
			update = update + inputLine + "\n";
		}

        System.out.println(update);
        JOptionPane.showMessageDialog(null, update); 
       }
     public void OptionPanel(){
         Options = true;
          options  = new Frame(){

      public synchronized void setTitle(String title) {
        super.setTitle(title);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
      }
     
 };
    //options.setResizable(false);
    options.setTitle("Options");
    options.setLayout(new GridBagLayout());
    options.setBackground(Color.DARK_GRAY);
    options.setAlwaysOnTop(true);
    JLabel info1 = new JLabel("  V-hold  ");
    JLabel info2 = new JLabel("  Volume  ");
    JLabel info3 = new JLabel("  Left  ");
    JLabel info4 = new JLabel("  Right  ");
    JLabel info5 = new JLabel(" Blaster Volume  ");
    ok.addActionListener(this);
    info1.setBackground(Color.DARK_GRAY);
    info2.setBackground(Color.DARK_GRAY);
    info3.setBackground(Color.DARK_GRAY);
    info4.setBackground(Color.DARK_GRAY);
    info5.setBackground(Color.DARK_GRAY);
    effect.setBackground(Color.DARK_GRAY);
    info1.setForeground(Color.LIGHT_GRAY);
    info2.setForeground(Color.LIGHT_GRAY);
    info3.setForeground(Color.LIGHT_GRAY);
    info4.setForeground(Color.LIGHT_GRAY);
    info5.setForeground(Color.LIGHT_GRAY);
    effect.setForeground(Color.LIGHT_GRAY);
    effect.setFocusable(false);
    ok.setBackground(Color.LIGHT_GRAY);
    ok.setForeground(Color.DARK_GRAY);
    ok.setBorder(new BevelBorder(BevelBorder.RAISED));
    
      options.add(info1, getGridBagConstraints(0, 0, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      options.add(vslider, getGridBagConstraints(0, 1, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      options.add(info2, getGridBagConstraints(2, 0, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      options.add(volumeslider, getGridBagConstraints(2, 1, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      options.add(info5, getGridBagConstraints(4, 0, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      options.add(bvolumeslider, getGridBagConstraints(4, 1, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      options.add(effect, getGridBagConstraints(5, 1, 1.0, 1.0, 1, GridBagConstraints.BOTH));
      options.add(info3, getGridBagConstraints(0, 4, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      options.add(info4, getGridBagConstraints(0, 6, 0.0, 0.0, 1, GridBagConstraints.BOTH));
      options.add(lslider, getGridBagConstraints(0, 5, 0.0, 0.0, 6, GridBagConstraints.BOTH));
      options.add(rslider, getGridBagConstraints(0, 7, 0.0, 0.0, 6, GridBagConstraints.BOTH));
      options.add(ok, getGridBagConstraints(0, 8, 0.0, 0.0, 2, GridBagConstraints.BOTH));
      options.setFocusable(false);
      options.pack();
      options.setVisible(true);
      ColorSlider();
      BlasterSlider();
      }
     
     public void ExpansionRom(){
         String oldSys = getComputer().toString();
               int length = oldSys.length();
                oldSys = oldSys.substring(10, (length));
                  try {
          setComputer("RAMSETTER", false);
          setComputer(oldSys, true);
          findWindow(this).pack();
          LoadFiles();
        } catch (final Exception ex) {
          ex.printStackTrace();
        }
     }
     public void ExpansionInfo(){
         String info = "|SHOW - open printer console\n|HIDE - hide printer console\n" +
                 "|ONLINE - sets printer online\n|OFFLINE - sets printer offline\n" +
                 "|CLEAR - clears printer console content\n|BIGGER - increases fontsize of printer\n" +
                 "|SMALLER - decreases fontsize\n|SIZE,[size] - sets fontsize in pt\n" +
                 "|FONT1 - |FONT9 - sets printerfont\n|QUIT - quits JavaCPC emulator\n" +
                 "|GREEN - emulates greenmonitor\n|GRAY / |GREY - emulates graymonitor\n" +
                 "|COLOR / |COLOUR - colourmonitor\n|32INKS - emulates JavaCPC specialinks\n"+
                 "|SCREENSHOT - Saves a screenshot\n|SAVEDSK - Lets the user save actual DSK in DF0\n"+
                 "|MAKEDSK - creates a DATA formatted DSK\n|SCANLINES - enables scanlines\n" +
                 "|SCANLINESOFF - disables scanlines\n|INFO / |HELP - this info";
         JOptionPane.showMessageDialog(frame, info);
     }
     
     public void ColorSlider(){
         int lastValue = 0;
             if (volumeslider.getValue () < lastValue)
                for (int i = volumeslider.getValue (); i < lastValue; i++)
                    ((JComponent) labels.get (new Integer (i))).setOpaque (false);
                else for (int i = lastValue; i < volumeslider.getValue (); i++)
                         ((JComponent) labels.get (new Integer (i))).setOpaque (true);

             lastValue = volumeslider.getValue ();
             volumeslider.repaint ();
             }
     
     public void BlasterSlider(){
         int lastValue = 0;
             if (bvolumeslider.getValue () < lastValue)
                for (int i = bvolumeslider.getValue (); i < lastValue; i++)
                    ((JComponent) blabels.get (new Integer (i))).setOpaque (false);
                else for (int i = lastValue; i < bvolumeslider.getValue (); i++)
                         ((JComponent) blabels.get (new Integer (i))).setOpaque (true);

             lastValue = bvolumeslider.getValue ();
             Switches.Blastervolume = lastValue;
             Settings.set(Settings.DBVOLUME, Util.hex(lastValue));
             bvolumeslider.repaint ();
             }
     
public void addSkin(){
          frame.setResizable(false);
                if (Monitoruppanel == null) {
                Monitoruppanel = getControlPanel();
                Monitoruppanel.setBackground(Color.DARK_GRAY);
                Monitordownpanel = getControlPanel();
                Monitordownpanel.setBackground(Color.DARK_GRAY);
                Monitorleftpanel = getControlPanel();
                Monitorleftpanel.setBackground(Color.DARK_GRAY);
                Monitorrightpanel = getControlPanel();
                Monitorrightpanel.setBackground(Color.DARK_GRAY);
                } 
      int[] pixelsc = new int[16 * 16];
Image imagec = Toolkit.getDefaultToolkit().createImage(
        new MemoryImageSource(16, 16, pixelsc, 0, 16));
Cursor blankCursor =
        Toolkit.getDefaultToolkit().createCustomCursor
             (imagec, new Point(0, 0), "invisibleCursor");
                Monitoruppanel.setCursor(blankCursor);
                Monitordownpanel.setCursor(blankCursor);
                Monitorleftpanel.setCursor(blankCursor);
                Monitorrightpanel.setCursor(blankCursor);
                  Moniup.addMouseListener(this);
                  Moniup.addMouseMotionListener(this);
                  Monidown.addMouseListener(this);
                  Monidown.addMouseMotionListener(this);
                  Monileft.addMouseListener(this);
                  Monileft.addMouseMotionListener(this);
                  Moniright.addMouseListener(this);
                  Moniright.addMouseMotionListener(this);
                  Moniup.addKeyListener(this);
                  Monidown.addKeyListener(this);
                  Monileft.addKeyListener(this);
                  Moniright.addKeyListener(this);
                  Monitoruppanel.add(this.Moniup, getGridBagConstraints(0, 0, 0.0, 0.0, 1, GridBagConstraints.BOTH));
                  Monitordownpanel.add(this.Monidown, getGridBagConstraints(0, 0, 0.0, 0.0, 1, GridBagConstraints.BOTH));
                  Monitorleftpanel.add(this.Monileft, getGridBagConstraints(0, 0, 0.0, 0.0, 1, GridBagConstraints.BOTH));
                  Monitorrightpanel.add(this.Moniright, getGridBagConstraints(0, 0, 0.0, 0.0, 1, GridBagConstraints.BOTH));
}
public void addStatus(){
        StatusPanel.setLayout(new GridBagLayout());
    Font font = new Font("Tahoma",1,6);
    Font font2 = new Font("Tahoma",1,12);
    jcbDrive.setFont(font);
    driveHead.setFont(font);
    Status1.setColumns(1);
    Status2.setColumns(1);
    Status2.setRows(1);
    Status2.setLineWrap(true);
    Status1.setEditable(false);
    Status2.setEditable(false);
    Status1.setOpaque(false);
    Status2.setOpaque(false);
    Status1.setFocusable(false);
    Status2.setFocusable(false);
    Status1.setBackground(Color.LIGHT_GRAY);
    Status2.setBackground(Color.LIGHT_GRAY);
    Status1.setFont(font2);
    Status2.setFont(font);
    StatusPanel.add(Status1, getGridBagConstraints(1, 0, 0.0, 0.0, 1, GridBagConstraints.BOTH));
    StatusPanel.add(Status2, getGridBagConstraints(2, 0, 0.0, 0.0, 1, GridBagConstraints.BOTH));
    StatusPanel.add(this.jcbDrive, getGridBagConstraints(3, 0, 1.0, 1.0, 1, GridBagConstraints.BOTH));
    StatusPanel.add(this.driveHead, getGridBagConstraints(4, 0, 1.0, 1.0, 1, GridBagConstraints.BOTH));
    add (StatusPanel, BorderLayout.SOUTH);
    StatusPanel.setVisible(true);
}
  public void chooseSNA(){
      snaChooser.setLayout(new GridBagLayout());
      s64.addActionListener(this);
      s128.addActionListener(this);
      s256.addActionListener(this);
      s512.addActionListener(this);
      cancel.addActionListener(this);
      s64.setFocusable(false);
      s128.setFocusable(false);
      s256.setFocusable(false);
      s512.setFocusable(false);
      cancel.setFocusable(false);
     snaChooser.add(Sn, getGridBagConstraints(1, 0, 1.0, 1.0, 4, GridBagConstraints.BOTH));
     snaChooser.add(s64, getGridBagConstraints(1, 1, 1.0, 1.0, 1, GridBagConstraints.BOTH));
     snaChooser.add(s128, getGridBagConstraints(2, 1, 1.0, 1.0, 1, GridBagConstraints.BOTH));
     snaChooser.add(s256, getGridBagConstraints(3, 1, 1.0, 1.0, 1, GridBagConstraints.BOTH));
     snaChooser.add(s512, getGridBagConstraints(4, 1, 1.0, 1.0, 1, GridBagConstraints.BOTH));
     snaChooser.add(cancel, getGridBagConstraints(1, 2, 1.0, 1.0, 1, GridBagConstraints.BOTH));
     snaChooser.pack();
     snaChooser.setAlwaysOnTop(true);
     snaChooser.setVisible(true);
  }
  
}